
namespace eval e_tile_pll {
  proc get_design_libraries {} {
    set libraries [dict create]
    dict set libraries altera_common_sv_packages 1
    dict set libraries xcvrnphy_fme_310          1
    dict set libraries e_tile_pll                1
    return $libraries
  }
  
  proc get_memory_files {QSYS_SIMDIR} {
    set memory_files [list]
    lappend memory_files "[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/serdes.firmware.rom"]"
    return $memory_files
  }
  
  proc get_common_design_files {USER_DEFINED_COMPILE_OPTIONS USER_DEFINED_VERILOG_COMPILE_OPTIONS USER_DEFINED_VHDL_COMPILE_OPTIONS QSYS_SIMDIR} {
    set design_files [dict create]
    dict set design_files "altera_common_sv_packages::altera_xcvr_native_s10_functions_h" "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_xcvr_native_s10_functions_h.sv"]\"  -work altera_common_sv_packages"
    return $design_files
  }
  
  proc get_design_files {USER_DEFINED_COMPILE_OPTIONS USER_DEFINED_VERILOG_COMPILE_OPTIONS USER_DEFINED_VHDL_COMPILE_OPTIONS QSYS_SIMDIR} {
    set design_files [list]
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/alt_xcvr_arbiter.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                      
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/mentor/alt_xcvr_arbiter.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"               
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_std_synchronizer_nocut.v"]\"  -work xcvrnphy_fme_310"                                          
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/alt_xcvr_resync_std.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                   
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/s10_avmm_h_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                      
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/alt_xcvr_native_avmm_csr_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"        
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/alt_xcvr_native_rcfg_arb.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"              
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/alt_xcvr_native_rx_reset_seq_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"    
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/alt_xcvr_native_tx_reset_seq_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"    
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/alt_xcvr_reset_counter_s10_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"      
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_xcvr_reset_control_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"       
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_xcvr_reset_top_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"           
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_xcvr_ical_int_table.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"            
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_xcvr_ical_top_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"            
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_xcvr_ical_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_xcvr_pma_spico_reset_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"     
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_xcvr_native_dskw_pam4.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"          
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/alt_xcvr_resync_etile.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"                 
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/altera_std_synchronizer_nocut_etile.v"]\"  -work xcvrnphy_fme_310"                                    
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/e_tile_pll_xcvrnphy_fme_310_4chc7ra.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"   
    lappend design_files "vlog -sv $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../xcvrnphy_fme_310/sim/alt_xcvr_native_rcfg_opt_logic_4chc7ra.sv"]\" -L altera_common_sv_packages -work xcvrnphy_fme_310"
    lappend design_files "vlog $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/e_tile_pll.v"]\"  -work e_tile_pll"                                                                                           
    return $design_files
  }
  
  proc get_elab_options {SIMULATOR_TOOL_BITNESS} {
    set ELAB_OPTIONS ""
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $ELAB_OPTIONS
  }
  
  
  proc get_sim_options {SIMULATOR_TOOL_BITNESS} {
    set SIM_OPTIONS ""
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $SIM_OPTIONS
  }
  
  
  proc get_env_variables {SIMULATOR_TOOL_BITNESS} {
    set ENV_VARIABLES [dict create]
    set LD_LIBRARY_PATH [dict create]
    dict set ENV_VARIABLES "LD_LIBRARY_PATH" $LD_LIBRARY_PATH
    if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
    } else {
    }
    return $ENV_VARIABLES
  }
  
  
  proc normalize_path {FILEPATH} {
      if {[catch { package require fileutil } err]} { 
          return $FILEPATH 
      } 
      set path [fileutil::lexnormalize [file join [pwd] $FILEPATH]]  
      if {[file pathtype $FILEPATH] eq "relative"} { 
          set path [fileutil::relative [pwd] $path] 
      } 
      return $path 
  } 
}
