// (C) 2001-2020 Intel Corporation. All rights reserved. 
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details. 

#ifndef INTEL_GENERIC_SERIAL_FLASH_INTERFACE_TOP_REGS_H_
#define INTEL_GENERIC_SERIAL_FLASH_INTERFACE_TOP_REGS_H_


#include <io.h>

#define INTEL_GSFI_CTR_REG                              0x0
#define INTEL_GSFI_BAUD_RATE_REG                        0x4
#define INTEL_GSFI_DELAY_REG                            0x8
#define INTEL_GSFI_READ_DELAY_REG                       0xC
#define INTEL_GSFI_PROTOCOL_REG                         0x10
#define INTEL_GSFI_READ_INST_REG                        0x14
#define INTEL_GSFI_WRITE_INST_REG                       0x18
#define INTEL_GSFI_FLASH_CMD_REG                        0x1C
#define INTEL_GSFI_START_CMD_REG                        0x20
#define INTEL_GSFI_ADDR_REG_REG                         0x24
#define INTEL_GSFI_WRITE_DATA0_REG                      0x28
#define INTEL_GSFI_WRITE_DATA1_REG                      0x2C
#define INTEL_GSFI_READ_DATA0_REG                       0x30
#define INTEL_GSFI_READ_DATA1_REG                       0x34

/* INTEL_GSFI_CTR_REG */
#define INTEL_GSFI_CTR_ADDR_MODE_MSK                   (1 << 8)
#define INTEL_GSFI_CTR_ADDR_MODE_OFST                   8
#define INTEL_GSFI_CTR_EN_MSK                          (1)
#define INTEL_GSFI_CTR_EN_OFST                          0

/* INTEL_GSFI_FLASH_CMD_REG */
#define INTEL_GSFI_CMD_NUM_DATA_BYTES_MSK              (15 << 12)
#define INTEL_GSFI_CMD_NUM_DATA_BYTES_OFST              12
#define INTEL_GSFI_CMD_READ_TYPE_MSK                   (1 << 11)
#define INTEL_GSFI_CMD_READ_TYPE_OFST                   11
#define INTEL_GSFI_CMD_NUM_ADDR_BYTES_MSK              (7 << 8)
#define INTEL_GSFI_CMD_NUM_ADDR_BYTES_OFST              8

/* INTEL_GSFI_START_CMD_REG, start operation bit */
#define INTEL_GSFI_START_CMD_MSK                       (1)
#define INTEL_GSFI_START_CMD_OFST                       0

/* INTEL_GSFI_CTR_REG */
#define IORD_INTEL_GSFI_CTR(base)   \
        IORD_32DIRECT(base, INTEL_GSFI_CTR_REG)
#define IOWR_INTEL_GSFI_CTR(base, data)  \
        IOWR_32DIRECT(base, INTEL_GSFI_CTR_REG, data)
/* INTEL_GSFI_BAUD_RATE_REG */        
#define IORD_INTEL_GSFI_BAUD_RATE(base) \
        IORD_32DIRECT(base, INTEL_GSFI_BAUD_RATE_REG)
#define IOWR_INTEL_GSFI_BAUD_RATE(base, data) \
        IOWR_32DIRECT(base, INTEL_GSFI_BAUD_RATE_REG, data)
/* INTEL_GSFI_DELAY_REG */        
#define IORD_INTEL_GSFI_DELAY(base) \
        IORD_32DIRECT(base, INTEL_GSFI_DELAY_REG)
#define IOWR_INTEL_GSFI_DELAY(base, data) \
        IOWR_32DIRECT(base, INTEL_GSFI_DELAY_REG, data)
/* INTEL_GSFI_READ_DELAY_REG */        
#define IORD_INTEL_GSFI_READ_DELAY(base) \
        IORD_32DIRECT(base, INTEL_GSFI_READ_DELAY_REG)
#define IOWR_INTEL_GSFI_READ_DELAY(base, data) \
        IOWR_32DIRECT(base, INTEL_GSFI_READ_DELAY_REG, data)
/* INTEL_GSFI_PROTOCOL_REG */        
#define IORD_INTEL_GSFI_PROTOCOL(base) \
        IORD_32DIRECT(base, INTEL_GSFI_PROTOCOL_REG)
#define IOWR_INTEL_GSFI_PROTOCOL(base, data) \
        IOWR_32DIRECT(base, INTEL_GSFI_PROTOCOL_REG, data)
/* INTEL_GSFI_READ_INST_REG */        
#define IORD_INTEL_GSFI_READ_INST(base) \
        IORD_32DIRECT(base, INTEL_GSFI_READ_INST_REG)
#define IOWR_INTEL_GSFI_READ_INST(base, data) \
        IOWR_32DIRECT(base, INTEL_GSFI_READ_INST_REG, data)
/* INTEL_GSFI_WRITE_INST_REG */
#define IORD_INTEL_GSFI_WRITE_INST(base) \
        IORD_32DIRECT(base, INTEL_GSFI_WRITE_INST_REG)
#define IOWR_INTEL_GSFI_WRITE_INST(base, data) \
        IOWR_32DIRECT(base, INTEL_GSFI_WRITE_INST_REG, data)
/* #define INTEL_GSFI_FLASH_CMD_REG */
#define IORD_INTEL_GSFI_FLASH_CMD(base) \
        IORD_32DIRECT(base, INTEL_GSFI_FLASH_CMD_REG)
#define IOWR_INTEL_GSFI_FLASH_CMD(base, data) \
        IOWR_32DIRECT(base, INTEL_GSFI_FLASH_CMD_REG, data)
/* INTEL_GSFI_START_CMD_REG */
#define IOWR_INTEL_GSFI_START_CMD(base, data) \
        IOWR_32DIRECT(base, INTEL_GSFI_START_CMD_REG, data)
/* INTEL_GSFI_ADDR_REG_REG */
#define IORD_INTEL_GSFI_ADDR_REG(base) \
        IORD_32DIRECT(base, INTEL_GSFI_ADDR_REG_REG)
#define IOWR_INTEL_GSFI_ADDR_REG(base, data) \
        IOWR_32DIRECT(base, INTEL_GSFI_ADDR_REG_REG, data)
/* INTEL_GSFI_WRITE_DATA0_REG */
#define IORD_INTEL_GSFI_WRITE_DATA0(base) \
        IORD_32DIRECT(base, INTEL_GSFI_WRITE_DATA0_REG)
#define IOWR_INTEL_GSFI_WRITE_DATA0(base, data) \
        IOWR_32DIRECT(base, INTEL_GSFI_WRITE_DATA0_REG, data)
/* INTEL_GSFI_WRITE_DATA1_REG */
#define IORD_INTEL_GSFI_WRITE_DATA1(base) \
        IORD_32DIRECT(base, INTEL_GSFI_WRITE_DATA1_REG)
#define IOWR_INTEL_GSFI_WRITE_DATA1(base, data) \
        IOWR_32DIRECT(base, INTEL_GSFI_WRITE_DATA1_REG, data)
/* INTEL_GSFI_READ_DATA0_REG */
#define IORD_INTEL_GSFI_READ_DATA0(base) \
        IORD_32DIRECT(base, INTEL_GSFI_READ_DATA0_REG)
/* INTEL_GSFI_READ_DATA1_REG */
#define IORD_INTEL_GSFI_READ_DATA1(base) \
        IORD_32DIRECT(base, INTEL_GSFI_READ_DATA1_REG)

#endif /* INTEL_GENERIC_SERIAL_FLASH_INTERFACE_TOP_REGS_H_ */
