/*
 * si5397A_config.h
 *
 *  Created on: 2014/7/11
 *      Author: Richard
 */

#ifndef SI5397A_CONFIG_H_
#define SI5397A_CONFIG_H_

#include <stdint.h>

/////////REGA Address Value///////////////////////
#define REGA_ADDR_PAGE      0x01
#define REGA_ADDR_000C      0x0C    // 2'h0, SMBUS_TIMEOUT, 1'h0 XAXB_ERR, LOSREF, LOSXAXB, SYSINCAL
#define REGA_ADDR_000D      0x0D    // OOF[3: 0], LOS_INTR_MSK[3: 0]
#define REGA_ADDR_000E      0x0E    // HOLD_PLL[3: 0], LOL_PLL[3: 0]
#define REGA_ADDR_0018      0x18    // OOF_INTR_MSK[3: 0], LOS_INTR_MSK[3: 0]
#define REGA_ADDR_0019      0x19    // HOLD_INTR_MSK_PLLD, HOLD_INTR_MSK_PLLC, HOLD_INTR_MSK_PLLB, HOLD_INTR_MSK_PLLA, LOL_INTR_MSK_PLLD, LOL_INTR_MSK_PLLC, LOL_INTR_MSK_PLLB, LOL_INTR_MSK_PLLA
#define REGA_ADDR_001A      0x1A    // CAL_INTR_MSK_PLLD, CAL_INTR_MSK_PLLC, CAL_INTR_MSK_PLLB, CAL_INTR_MSK_PLLA, 4'h0
#define REGA_ADDR_002C      0x2C    // 3'h0, LOSXAXB_DIS, LOS_EN[3: 0]
#define REGA_ADDR_002E      0x2E    // LOS0_TRG_THR[7 :0]
#define REGA_ADDR_002F      0x2F    // LOS0_TRG_THR[15:8]
#define REGA_ADDR_0030      0x30    // LOS1_TRG_THR[7 :0]
#define REGA_ADDR_0031      0x31    // LOS1_TRG_THR[15:8]
#define REGA_ADDR_0032      0x32    // LOS2_TRG_THR[7 :0]
#define REGA_ADDR_0033      0x33    // LOS2_TRG_THR[15:8]
#define REGA_ADDR_0034      0x34    // LOS3_TRG_THR[7 :0]
#define REGA_ADDR_0035      0x35    // LOS3_TRG_THR[15:8]
#define REGA_ADDR_0036      0x36    // LOS0_CLR_THR[7 :0]
#define REGA_ADDR_0037      0x37    // LOS0_CLR_THR[15:8]
#define REGA_ADDR_0038      0x38    // LOS1_CLR_THR[7 :0]
#define REGA_ADDR_0039      0x39    // LOS1_CLR_THR[15:8]
#define REGA_ADDR_003A      0x3A    // LOS2_CLR_THR[7 :0]
#define REGA_ADDR_003B      0x3B    // LOS2_CLR_THR[15:8]
#define REGA_ADDR_003C      0x3C    // LOS3_CLR_THR[7 :0]
#define REGA_ADDR_003D      0x3D    // LOS3_CLR_THR[15:8]
#define REGA_ADDR_003E      0x3E    // LOS_MIN_PERIOD_EN[3: 0], 4'h0
#define REGA_ADDR_003F      0x3F    // FAST_OOF_EN[3: 0], OOF_EN[3: 0]
#define REGA_ADDR_0040      0x40    // 5'h0, OOF_REF_SEL[2: 0]
#define REGA_ADDR_0041      0x41    // 3'h0, OOF0_DIV_SEL[4: 0]
#define REGA_ADDR_0042      0x42    // 3'h0, OOF1_DIV_SEL[4: 0]
#define REGA_ADDR_0043      0x43    // 3'h0, OOF2_DIV_SEL[4: 0]
#define REGA_ADDR_0044      0x44    // 3'h0, OOF3_DIV_SEL[4: 0]
#define REGA_ADDR_0046      0x46    // OOF0_SET_THR[7: 0]
#define REGA_ADDR_0047      0x47    // OOF1_SET_THR[7: 0]
#define REGA_ADDR_0048      0x48    // OOF2_SET_THR[7: 0]
#define REGA_ADDR_0049      0x49    // OOF3_SET_THR[7: 0]
#define REGA_ADDR_004A      0x4A    // OOF0_CLR_THR[7: 0]
#define REGA_ADDR_004B      0x4B    // OOF1_CLR_THR[7: 0]
#define REGA_ADDR_004C      0x4C    // OOF2_CLR_THR[7: 0]
#define REGA_ADDR_004D      0x4D    // OOF3_CLR_THR[7: 0]
#define REGA_ADDR_004E      0x4E    // 1'h0, OOF1_DETWIN_SEL[2: 0], 1'h0, OOF0_DETWIN_SEL[2: 0]
#define REGA_ADDR_004F      0x4F    // 1'h0, OOF3_DETWIN_SEL[2: 0], 1'h0, OOF2_DETWIN_SEL[2: 0]
#define REGA_ADDR_0050      0x50    // 4'h0, OOF_ON_LOS[3: 0]
#define REGA_ADDR_0051      0x51    // 4'h0, FAST_OOF0_SET_THR[3: 0]
#define REGA_ADDR_0052      0x52    // 4'h0, FAST_OOF1_SET_THR[3: 0]
#define REGA_ADDR_0053      0x53    // 4'h0, FAST_OOF2_SET_THR[3: 0]
#define REGA_ADDR_0054      0x54    // 4'h0, FAST_OOF3_SET_THR[3: 0]
#define REGA_ADDR_0055      0x55    // 4'h0, FAST_OOF0_CLR_THR[3: 0]
#define REGA_ADDR_0056      0x56    // 4'h0, FAST_OOF1_CLR_THR[3: 0]
#define REGA_ADDR_0057      0x57    // 4'h0, FAST_OOF2_CLR_THR[3: 0]
#define REGA_ADDR_0058      0x58    // 4'h0, FAST_OOF3_CLR_THR[3: 0]
#define REGA_ADDR_0059      0x59    // FAST_OOF3_DETWIN_SEL[1: 0], FAST_OOF2_DETWIN_SEL[1: 0], FAST_OOF1_DETWIN_SEL[1: 0], FAST_OOF0_DETWIN_SEL[1: 0]
#define REGA_ADDR_005A      0x5A    // OOF0_RATIO_REF[7:0  ]
#define REGA_ADDR_005B      0x5B    // OOF0_RATIO_REF[15:8 ]
#define REGA_ADDR_005C      0x5C    // OOF0_RATIO_REF[23:16]
#define REGA_ADDR_005D      0x5D    // 6'h0, OOF0_RATIO_REF[25:24]
#define REGA_ADDR_005E      0x5E    // OOF1_RATIO_REF[7:0  ]
#define REGA_ADDR_005F      0x5F    // OOF1_RATIO_REF[15:8 ]
#define REGA_ADDR_0060      0x60    // OOF1_RATIO_REF[23:16]
#define REGA_ADDR_0061      0x61    // 6'h0, OOF1_RATIO_REF[25:24]
#define REGA_ADDR_0062      0x62    // OOF2_RATIO_REF [7:0  ]
#define REGA_ADDR_0063      0x63    // OOF2_RATIO_REF [15:8 ]
#define REGA_ADDR_0064      0x64    // OOF2_RATIO_REF [23:16]
#define REGA_ADDR_0065      0x65    // 6'h0, OOF2_RATIO_REF [25:24]
#define REGA_ADDR_0066      0x66    // OOF3_RATIO_REF [7:0  ]
#define REGA_ADDR_0067      0x67    // OOF3_RATIO_REF [15:8 ]
#define REGA_ADDR_0068      0x68    // OOF3_RATIO_REF [23:16]
#define REGA_ADDR_0069      0x69    // 6'h0, OOF3_RATIO_REF [25:24]
#define REGA_ADDR_0092      0x92    // 4'h0, LOL_FST_EN_PLLD, LOL_FST_EN_PLLC, LOL_FST_EN_PLLB, LOL_FST_EN_PLLA
#define REGA_ADDR_0094      0x94    // LOL_FST_DETWIN_SEL_PLLD[3: 0], LOL_FST_DETWIN_SEL_PLLC[3: 0]
#define REGA_ADDR_0097      0x97    // LOL_FST_SET_THR_SEL_PLLD[3: 0], LOL_FST_SET_THR_SEL_PLLC[3: 0]
#define REGA_ADDR_0099      0x99    // LOL_FST_CLR_THR_SEL_PLLD[3: 0], LOL_FST_CLR_THR_SEL_PLLC[3: 0]
#define REGA_ADDR_009A      0x9A    // 4'h0, LOL_SLOW_EN_PLLD, LOL_SLOW_EN_PLLC, LOL_SLOW_EN_PLLB, LOL_SLOW_EN_PLLA
#define REGA_ADDR_009C      0x9C    // LOL_SLW_DETWIN_SEL_PLLD[3: 0], LOL_SLW_DETWIN_SEL_PLLC[3: 0]
#define REGA_ADDR_009D      0x9D    // LOL_SLW_VALWIN_SEL_PLLD[1: 0], LOL_SLW_VALWIN_SEL_PLLC[1: 0], LOL_SLW_VALWIN_SEL_PLLB[1: 0], LOL_SLW_VALWIN_SEL_PLLA[1: 0]
#define REGA_ADDR_009F      0x9F    // LOL_SLW_SET_THR_PLLD[3: 0], LOL_SLW_SET_THR_PLLC[3: 0]
#define REGA_ADDR_00A1      0xA1    // LOL_SLW_CLR_THR_PLLD[3: 0], LOL_SLW_CLR_THR_PLLC[3: 0]
#define REGA_ADDR_00AE      0xAE    // LOL_CLR_DELAY_DIV256_PLLC[7:0  ]
#define REGA_ADDR_00AF      0xAF    // LOL_CLR_DELAY_DIV256_PLLC[15:8 ]
#define REGA_ADDR_00B0      0xB0    // LOL_CLR_DELAY_DIV256_PLLC[23:16]
#define REGA_ADDR_00B1      0xB1    // 3'h0, LOL_CLR_DELAY_DIV256_PLLC[28:24]
#define REGA_ADDR_00B3      0xB3    // LOL_CLR_DELAY_DIV256_PLLD[7:0  ]
#define REGA_ADDR_00B4      0xB4    // LOL_CLR_DELAY_DIV256_PLLD[15:8 ]
#define REGA_ADDR_00B5      0xB5    // LOL_CLR_DELAY_DIV256_PLLD[23:16]
#define REGA_ADDR_00B6      0xB6    // 3'h0, LOL_CLR_DELAY_DIV256_PLLD[28:24]
#define REGA_ADDR_00EE      0xEE    // FASTLOCK_EXTEND_PLLC[7:0  ]
#define REGA_ADDR_00EF      0xEF    // FASTLOCK_EXTEND_PLLC[15:8 ]
#define REGA_ADDR_00F0      0xF0    // FASTLOCK_EXTEND_PLLC[23:16]
#define REGA_ADDR_00F1      0xF1    // 3'h0, FASTLOCK_EXTEND_PLLC[28:24]
#define REGA_ADDR_00F2      0xF2    // FASTLOCK_EXTEND_PLLD[7:0  ]
#define REGA_ADDR_00F3      0xF3    // FASTLOCK_EXTEND_PLLD[15:8 ]
#define REGA_ADDR_00F4      0xF4    // FASTLOCK_EXTEND_PLLD[23:16]
#define REGA_ADDR_00F5      0xF5    // 3'h0, FASTLOCK_EXTEND_PLLD[28:24]
#define REGA_ADDR_0108      0x08    // 5'h0, OUT0_RDIV_FORCE2, OUT0_OE, OUT0_PDN
#define REGA_ADDR_010B      0x0B    // OUT0_INV[1: 0], OUT0_VDD_SEL[1: 0], OUT0_VDD_SEL_EN, OUT0_MUX_SEL[2: 0]
#define REGA_ADDR_0117      0x17    // 5'h0, OUT2_RDIV_FORCE2, OUT2_OE, OUT2_PDN
#define REGA_ADDR_011A      0x1A    // OUT2_INV[1: 0], OUT2_VDD_SEL[1: 0], OUT2_VDD_SEL_EN, OUT2_MUX_SEL[2: 0]
#define REGA_ADDR_0126      0x26    // 5'h0, OUT4_RDIV_FORCE2, OUT4_OE, OUT4_PDN
#define REGA_ADDR_0129      0x29    // OUT4_INV[1: 0], OUT4_VDD_SEL[1: 0], OUT4_VDD_SEL_EN, OUT4_MUX_SEL[2: 0]
#define REGA_ADDR_0130      0x30    // 5'h0, OUT6_RDIV_FORCE2, OUT6_OE, OUT6_PDN
#define REGA_ADDR_0133      0x33    // OUT6_INV[1: 0], OUT6_VDD_SEL[1: 0], OUT6_VDD_SEL_EN, OUT6_MUX_SEL[2: 0]
#define REGA_ADDR_013A      0x3A    // 5'h0, OUT7_RDIV_FORCE2, OUT7_OE, OUT7_PDN
#define REGA_ADDR_013D      0x3D    // OUT7_INV[1: 0], OUT7_VDD_SEL[1: 0], OUT7_VDD_SEL_EN, OUT7_MUX_SEL[2: 0]
#define REGA_ADDR_0206      0x06    // 6'h0, PXAXB[1: 0]
#define REGA_ADDR_0208      0x08    // P0_NUM[7:0  ]
#define REGA_ADDR_0209      0x09    // P0_NUM[15:8 ]
#define REGA_ADDR_020A      0x0A    // P0_NUM[23:16]
#define REGA_ADDR_020B      0x0B    // P0_NUM[31:24]
#define REGA_ADDR_020C      0x0C    // P0_NUM[39:32]
#define REGA_ADDR_020D      0x0D    // P0_NUM[47:40]
#define REGA_ADDR_020E      0x0E    // P0_DEN[7:0  ]
#define REGA_ADDR_020F      0x0F    // P0_DEN[15:8 ]
#define REGA_ADDR_0210      0x10    // P0_DEN[23:16]
#define REGA_ADDR_0211      0x11    // P0_DEN[31:24]
#define REGA_ADDR_0212      0x12    // P1_NUM[7:0  ]
#define REGA_ADDR_0213      0x13    // P1_NUM[15:8 ]
#define REGA_ADDR_0214      0x14    // P1_NUM[23:16]
#define REGA_ADDR_0215      0x15    // P1_NUM[31:24]
#define REGA_ADDR_0216      0x16    // P1_NUM[39:32]
#define REGA_ADDR_0217      0x17    // P1_NUM[47:40]
#define REGA_ADDR_0218      0x18    // P1_DEN[7:0  ]
#define REGA_ADDR_0219      0x19    // P1_DEN[15:8 ]
#define REGA_ADDR_021A      0x1A    // P1_DEN[23:16]
#define REGA_ADDR_021B      0x1B    // P1_DEN[31:24]
#define REGA_ADDR_021C      0x1C    // P2_NUM[7:0  ]
#define REGA_ADDR_021D      0x1D    // P2_NUM[15:8 ]
#define REGA_ADDR_021E      0x1E    // P2_NUM[23:16]
#define REGA_ADDR_021F      0x1F    // P2_NUM[31:24]
#define REGA_ADDR_0220      0x20    // P2_NUM[39:32]
#define REGA_ADDR_0221      0x21    // P2_NUM[47:40]
#define REGA_ADDR_0222      0x22    // P2_DEN[7:0  ]
#define REGA_ADDR_0223      0x23    // P2_DEN[15:8 ]
#define REGA_ADDR_0224      0x24    // P2_DEN[23:16]
#define REGA_ADDR_0225      0x25    // P2_DEN[31:24]
#define REGA_ADDR_0226      0x26    // P3_NUM[7:0  ]
#define REGA_ADDR_0227      0x27    // P3_NUM[15:8 ]
#define REGA_ADDR_0228      0x28    // P3_NUM[23:16]
#define REGA_ADDR_0229      0x29    // P3_NUM[31:24]
#define REGA_ADDR_022A      0x2A    // P3_NUM[39:32]
#define REGA_ADDR_022B      0x2B    // P3_NUM[47:40]
#define REGA_ADDR_022C      0x2C    // P3_DEN[7:0  ]
#define REGA_ADDR_022D      0x2D    // P3_DEN[15:8 ]
#define REGA_ADDR_022E      0x2E    // P3_DEN[23:16]
#define REGA_ADDR_022F      0x2F    // P3_DEN[31:24]
#define REGA_ADDR_0230      0x30    // 4'h0, P3_UPDATE, P2_UPDATE, P1_UPDATE, P0_UPDATE
#define REGA_ADDR_0231      0x31    // 3'h0, P0_FRACN_EN, P0_FRACN_MODE[3:0]
#define REGA_ADDR_0232      0x32    // 3'h0, P1_FRACN_EN, P1_FRACN_MODE[3:0]
#define REGA_ADDR_0233      0x33    // 3'h0, P2_FRACN_EN, P2_FRACN_MODE[3:0]
#define REGA_ADDR_0234      0x34    // 3'h0, P3_FRACN_EN, P3_FRACN_MODE[3:0]
#define REGA_ADDR_0235      0x35    // M_NUM[7:0  ]
#define REGA_ADDR_0236      0x36    // M_NUM[15:8 ]
#define REGA_ADDR_0237      0x37    // M_NUM[23:16]
#define REGA_ADDR_0238      0x38    // M_NUM[31:24]
#define REGA_ADDR_0239      0x39    // M_NUM[39:32]
#define REGA_ADDR_023A      0x3A    // 4'h0, M_NUM[43:40]
#define REGA_ADDR_023B      0x3B    // M_DEN[7:0  ]
#define REGA_ADDR_023C      0x3C    // M_DEN[15:8 ]
#define REGA_ADDR_023D      0x3D    // M_DEN[23:16]
#define REGA_ADDR_023E      0x3E    // M_DEN[31:24]
#define REGA_ADDR_023F      0x3F    // 7'h0, MXAXB_UPDATE
#define REGA_ADDR_024A      0x4A    // R0_REG[7:0  ]
#define REGA_ADDR_024B      0x4B    // R0_REG[15:8 ]
#define REGA_ADDR_024C      0x4C    // R0_REG[23:16]
#define REGA_ADDR_0253      0x53    // R2_REG[7:0  ]
#define REGA_ADDR_0254      0x54    // R2_REG[15:8 ]
#define REGA_ADDR_0255      0x55    // R2_REG[23:16]
#define REGA_ADDR_025C      0x5C    // R4_REG[7:0  ]
#define REGA_ADDR_025D      0x5D    // R4_REG[15:8 ]
#define REGA_ADDR_025E      0x5E    // R4_REG[23:16]
#define REGA_ADDR_0262      0x62    // R6_REG[7:0  ]
#define REGA_ADDR_0263      0x63    // R6_REG[15:8 ]
#define REGA_ADDR_0264      0x64    // R6_REG[23:16]
#define REGA_ADDR_0268      0x68    // R7_REG[7:0  ]
#define REGA_ADDR_0269      0x69    // R7_REG[15:8 ]
#define REGA_ADDR_026A      0x6A    // R7_REG[23:16]
#define REGA_ADDR_0292      0x92    // 4'h0, OOF_STOP_ON_LOS[3: 0]
#define REGA_ADDR_0293      0x93    // 4'h0, OOF_CLEAR_ON_LOS[3: 0]
#define REGA_ADDR_0295      0x95    // FASTLOCK_EXTEND_SCL_PLLD,[3: 0] FASTLOCK_EXTEND_SCL_PLLC[3: 0]
#define REGA_ADDR_0296      0x96    // 4'h0, LOL_SLW_VALWIN_SELX_PLLD, LOL_SLW_VALWIN_SELX_PLLC, LOL_SLW_VALWIN_SELX_PLLB, LOL_SLW_VALWIN_SELX_PLLA
#define REGA_ADDR_0297      0x97    // 4'h0, FASTLOCK_DLY_ONSW_EN_PLLD, FASTLOCK_DLY_ONSW_EN_PLLC, FASTLOCK_DLY_ONSW_EN_PLLB, FASTLOCK_DLY_ONSW_EN_PLLA
#define REGA_ADDR_0299      0x99    // 4'h0, FASTLOCK_DLY_ONLOL_EN_PLLD, FASTLOCK_DLY_ONLOL_EN_PLLC, FASTLOCK_DLY_ONLOL_EN_PLLB, FASTLOCK_DLY_ONLOL_EN_PLLA
#define REGA_ADDR_02A0      0xA0    // FASTLOCK_DLY_ONLOL_PLLC[7:0  ]
#define REGA_ADDR_02A1      0xA1    // FASTLOCK_DLY_ONLOL_PLLC[15:8 ]
#define REGA_ADDR_02A2      0xA2    // 4'h0, FASTLOCK_DLY_ONLOL_PLLC[19:16]
#define REGA_ADDR_02A3      0xA3    // FASTLOCK_DLY_ONLOL_PLLD[7:0  ]
#define REGA_ADDR_02A4      0xA4    // FASTLOCK_DLY_ONLOL_PLLD[15:8 ]
#define REGA_ADDR_02A5      0xA5    // 4'h0, FASTLOCK_DLY_ONLOL_PLLD[19:16]
#define REGA_ADDR_02AC      0xAC    // FASTLOCK_DLY_ONSW_PLLC[7:0  ]
#define REGA_ADDR_02AD      0xAD    // FASTLOCK_DLY_ONSW_PLLC[15:8 ]
#define REGA_ADDR_02AE      0xAE    // 4'h0, FASTLOCK_DLY_ONSW_PLLC[19:16]
#define REGA_ADDR_02AF      0xAF    // FASTLOCK_DLY_ONSW_PLLD[7:0  ]
#define REGA_ADDR_02B0      0xB0    // FASTLOCK_DLY_ONSW_PLLD[15:8 ]
#define REGA_ADDR_02B1      0xB1    // 4'h0, FASTLOCK_DLY_ONSW_PLLD[19:16]
#define REGA_ADDR_0302      0x02    // N0_NUM[7:0  ]
#define REGA_ADDR_0303      0x03    // N0_NUM[15:8 ]
#define REGA_ADDR_0304      0x04    // N0_NUM[23:16]
#define REGA_ADDR_0305      0x05    // N0_NUM[31:24]
#define REGA_ADDR_0306      0x06    // N0_NUM[39:32]
#define REGA_ADDR_0307      0x07    // 4'h0, N0_NUM[43:40]
#define REGA_ADDR_0308      0x08    // N0_DEN[7:0  ]
#define REGA_ADDR_0309      0x09    // N0_DEN[15:8 ]
#define REGA_ADDR_030A      0x0A    // N0_DEN[23:16]
#define REGA_ADDR_030B      0x0B    // N0_DEN[31:24]
#define REGA_ADDR_030C      0x0C    // 7'h0, N0_UPDATE
#define REGA_ADDR_030D      0x0D    // N1_NUM[7:0  ]
#define REGA_ADDR_030E      0x0E    // N1_NUM[15:8 ]
#define REGA_ADDR_030F      0x0F    // N1_NUM[23:16]
#define REGA_ADDR_0310      0x10    // N1_NUM[31:24]
#define REGA_ADDR_0311      0x11    // N1_NUM[39:32]
#define REGA_ADDR_0312      0x12    // 4'h0, N1_NUM[43:40]
#define REGA_ADDR_0313      0x13    // N1_DEN[7:0  ]
#define REGA_ADDR_0314      0x14    // N1_DEN[15:8 ]
#define REGA_ADDR_0315      0x15    // N1_DEN[23:16]
#define REGA_ADDR_0316      0x16    // N1_DEN[31:24]
#define REGA_ADDR_0317      0x17    // 7'h0, N1_UPDATE
#define REGA_ADDR_0318      0x18    // N2_NUM[7:0  ]
#define REGA_ADDR_0319      0x19    // N2_NUM[15:8 ]
#define REGA_ADDR_031A      0x1A    // N2_NUM[23:16]
#define REGA_ADDR_031B      0x1B    // N2_NUM[31:24]
#define REGA_ADDR_031C      0x1C    // N2_NUM[39:32]
#define REGA_ADDR_031D      0x1D    // 4'h0, N2_NUM[43:40]
#define REGA_ADDR_031E      0x1E    // N2_DEN[7:0  ]
#define REGA_ADDR_031F      0x1F    // N2_DEN[15:8 ]
#define REGA_ADDR_0320      0x20    // N2_DEN[23:16]
#define REGA_ADDR_0321      0x21    // N2_DEN[31:24]
#define REGA_ADDR_0322      0x22    // 7'h0, N2_UPDATE
#define REGA_ADDR_0323      0x23    // N3_NUM[7:0  ]
#define REGA_ADDR_0324      0x24    // N3_NUM[15:8 ]
#define REGA_ADDR_0325      0x25    // N3_NUM[23:16]
#define REGA_ADDR_0326      0x26    // N3_NUM[31:24]
#define REGA_ADDR_0327      0x27    // N3_NUM[39:32]
#define REGA_ADDR_0328      0x28    // 4'h0, N3_NUM[43:40]
#define REGA_ADDR_0329      0x29    // N3_DEN[7:0  ]
#define REGA_ADDR_032A      0x2A    // N3_DEN[15:8 ]
#define REGA_ADDR_032B      0x2B    // N3_DEN[23:16]
#define REGA_ADDR_032C      0x2C    // N3_DEN[31:24]
#define REGA_ADDR_032D      0x2D    // 7'h0, N3_UPDATE
#define REGA_ADDR_0338      0x38    // 7'h0, N_UPDATE // Writing a 1 to this bit will update all DSPLL internal divider values. When this bit is written, all other bits in this//register must be written as zeros.
#define REGA_ADDR_0420      0x20    // 7'h0, M_UPDATE_PLLA // Must write a 1 to this bit to cause the individual M divider changes to take effect. Note that a corresponding SOFT_RST_PLLx or device SOFT_RST will also update the M divider values.
#define REGA_ADDR_0520      0x20    // 7'h0, M_UPDATE_PLLB
#define REGA_ADDR_0608      0x08    // 2'h0, BW0_PLLC[5: 0]
#define REGA_ADDR_0609      0x09    // 2'h0, BW1_PLLC[5: 0]
#define REGA_ADDR_060A      0x0A    // 2'h0, BW2_PLLC[5: 0]
#define REGA_ADDR_060B      0x0B    // 2'h0, BW3_PLLC[5: 0]
#define REGA_ADDR_060C      0x0C    // 2'h0, BW4_PLLC[5: 0]
#define REGA_ADDR_060D      0x0D    // 2'h0, BW5_PLLC[5: 0]
#define REGA_ADDR_060E      0x0E    // 2'h0, FASTLOCK_BW0_PLLC[5: 0]
#define REGA_ADDR_060F      0x0F    // 2'h0, FASTLOCK_BW1_PLLC[5: 0]
#define REGA_ADDR_0610      0x10    // 2'h0, FASTLOCK_BW2_PLLC[5: 0]
#define REGA_ADDR_0611      0x11    // 2'h0, FASTLOCK_BW3_PLLC[5: 0]
#define REGA_ADDR_0612      0x12    // 2'h0, FASTLOCK_BW4_PLLC[5: 0]
#define REGA_ADDR_0613      0x13    // 2'h0, FASTLOCK_BW5_PLLC[5: 0]
#define REGA_ADDR_0614      0x14    // 7'h0, BW_UPDATE_PLLC
#define REGA_ADDR_0615      0x15    // M_NUM_PLLC[7:0  ]
#define REGA_ADDR_0616      0x16    // M_NUM_PLLC[15:8 ]
#define REGA_ADDR_0617      0x17    // M_NUM_PLLC[23:16]
#define REGA_ADDR_0618      0x18    // M_NUM_PLLC[31:24]
#define REGA_ADDR_0619      0x19    // M_NUM_PLLC[39:32]
#define REGA_ADDR_061A      0x1A    // M_NUM_PLLC[47:40]
#define REGA_ADDR_061B      0x1B    // M_NUM_PLLC[55:48]
#define REGA_ADDR_061C      0x1C    // M_DEN_PLLC[7:0  ]
#define REGA_ADDR_061D      0x1D    // M_DEN_PLLC[15:8 ]
#define REGA_ADDR_061E      0x1E    // M_DEN_PLLC[23:16]
#define REGA_ADDR_061F      0x1F    // M_DEN_PLLC[31:24]
#define REGA_ADDR_0620      0x20    // 7'h0, M_UPDATE_PLLC
#define REGA_ADDR_0621      0x21    // 3'h1, M_FRAC_EN_PLLC, M_FRAC_MODE_PLLC[3: 0]
#define REGA_ADDR_0622      0x22    // 6'h0, M_FSTEPW_DEN_PLLC, M_FSTEP_MSK_PLLC
#define REGA_ADDR_0623      0x23    // M_FSTEPW_PLLC[7:0  ]
#define REGA_ADDR_0624      0x24    // M_FSTEPW_PLLC[15:8 ]
#define REGA_ADDR_0625      0x25    // M_FSTEPW_PLLC[23:16]
#define REGA_ADDR_0626      0x26    // M_FSTEPW_PLLC[31:24]
#define REGA_ADDR_0627      0x27    // M_FSTEPW_PLLC[39:32]
#define REGA_ADDR_0628      0x28    // M_FSTEPW_PLLC[47:40]
#define REGA_ADDR_0629      0x29    // M_FSTEPW_PLLC[55:48]
#define REGA_ADDR_062A      0x2A    // 5'h0, IN_SEL_PLLC[2: 0]
#define REGA_ADDR_062B      0x2B    // 6'h0, FASTLOCK_MAN_PLLC, FASTLOCK_AUTO_EN_PLLC
#define REGA_ADDR_062C      0x2C    // RAMP_STEP_INTERVAL_PLLC[2: 0], HOLDEXIT_BW_SEL1_PLLC, HOLD_RAMP_BYP_PLLC, 2'h3, HOLD_EN_PLLC
#define REGA_ADDR_062E      0x2E    // 3'h0, HOLD_HIST_LEN_PLLC[4: 0]
#define REGA_ADDR_062F      0x2F    // 3'h0, HOLD_HIST_DELAY_PLLC[4: 0]
#define REGA_ADDR_0632      0x32    // HOLD_15M_CYC_COUNT_PLLC[7:0  ]
#define REGA_ADDR_0633      0x33    // HOLD_15M_CYC_COUNT_PLLC[15:8 ]
#define REGA_ADDR_0634      0x34    // HOLD_15M_CYC_COUNT_PLLC[23:16]
#define REGA_ADDR_0635      0x35    // 7'h0, FORCE_HOLD_PLLC
#define REGA_ADDR_0636      0x36    // 5'h0, HSW_EN_PLLC, CLK_SWITCH_MODE_PLLC[1: 0]
#define REGA_ADDR_063A      0x3A    // 4'h0, HSW_PHMEAS_CTRL_PLLC[1: 0] , HSW_MODE_PLLC[1: 0]
#define REGA_ADDR_063B      0x3B    // HSW_PHMEAS_THR_PLLC[7: 0]
#define REGA_ADDR_063C      0x3C    // 6'h0, HSW_PHMEAS_THR_PLLC[1: 0]
#define REGA_ADDR_063D      0x3D    // 3'h0, HSW_COARSE_PM_LEN_PLLC[4: 0]
#define REGA_ADDR_063E      0x3E    // 3'h0, HSW_COARSE_PM_DLY_PLLC[4: 0]
#define REGA_ADDR_0688      0x88    // 4'h0, HSW_FINE_PM_LEN_PLLC[3: 0]
#define REGA_ADDR_0689      0x89    // PFD_EN_DELAY_PLLC[7: 0]
#define REGA_ADDR_068A      0x8A    // 3'h0, PFD_EN_DELAY_PLLC[12: 8]
#define REGA_ADDR_068B      0x8B    // HSW_MEAS_SETTLE_PLLC[7:0  ]
#define REGA_ADDR_068C      0x8C    // HSW_MEAS_SETTLE_PLLC[15:8 ]
#define REGA_ADDR_068D      0x8D    // 4'h0, HSW_MEAS_SETTLE_PLLC[19:16]
#define REGA_ADDR_069B      0x9B    /*
                                     HOLDEXIT_STD_BO_PLLC,
                                     HOLDEXIT_BW_SEL0_PLLC,
                                     HOLD_FRZ_WITH_INTONLY_PLLC,
                                     HOLD_PRESERVE_HIST_PLLC,
                                     1'h1,
                                     HO_SKIP_PHASE_PLLC,
                                     INIT_LP_CLOSE_HO_PLLC,
                                     1'h0
                                    */
#define REGA_ADDR_069C      0x9C    // HOLD_RAMPPB_NOHIST_PLLC, HOLDEXIT_ST_BO_PLLC, 2'h0, 4'hc
#define REGA_ADDR_069D      0x9D    // 2'h0, HOLDEXIT_BW0_PLLC[5: 0]
#define REGA_ADDR_069E      0x9E    // 2'h0, HOLDEXIT_BW1_PLLC[5: 0]
#define REGA_ADDR_069F      0x9F    // 2'h0, HOLDEXIT_BW2_PLLC[5: 0]
#define REGA_ADDR_06A0      0xA0    // 2'h0, HOLDEXIT_BW3_PLLC[5: 0]
#define REGA_ADDR_06A1      0xA1    // 2'h0, HOLDEXIT_BW4_PLLC[5: 0]
#define REGA_ADDR_06A2      0xA2    // 2'h0, HOLDEXIT_BW5_PLLC[5: 0]
#define REGA_ADDR_06A4      0xA4    // HSW_LIMIT_PLLC[7: 0]
#define REGA_ADDR_06A5      0xA5    // 7'h0, HSW_LIMIT_ACTION_PLLC
#define REGA_ADDR_06A6      0xA6    // 4'h0, RAMP_SWITCH_EN_PLLC, RAMP_STEP_SIZE_PLLC[2: 0]
#define REGA_ADDR_06AC      0xAC    // 4'h0, HOLD_SETTLE_DET_EN_DSPLLC, 2'h0, OUT_MAX_LIMIT_EN_PLLC
#define REGA_ADDR_06AD      0xAD    // OUT_MAX_LIMIT_LMT_DPSLLC[7 :0] //same OUT_MAX_LIMIT_LMT_PLL
#define REGA_ADDR_06AE      0xAE    // OUT_MAX_LIMIT_LMT_DPSLLC[15:8]
#define REGA_ADDR_06B1      0xB1    // HOLD_SETTLE_TARGET_DSPLLC[7 :0]
#define REGA_ADDR_06B2      0xB2    // HOLD_SETTLE_TARGET_DSPLLC[15:8]
#define REGA_ADDR_0709      0x09    // 2'h0, BW0_PLLD[5: 0]
#define REGA_ADDR_070A      0x0A    // 2'h0, BW1_PLLD[5: 0]
#define REGA_ADDR_070B      0x0B    // 2'h0, BW2_PLLD[5: 0]
#define REGA_ADDR_070C      0x0C    // 2'h0, BW3_PLLD[5: 0]
#define REGA_ADDR_070D      0x0D    // 2'h0, BW4_PLLD[5: 0]
#define REGA_ADDR_070E      0x0E    // 2'h0, BW5_PLLD[5: 0]
#define REGA_ADDR_070F      0x0F    // 2'h0, FASTLOCK_BW0_PLLD[5: 0]
#define REGA_ADDR_0710      0x10    // 2'h0, FASTLOCK_BW1_PLLD[5: 0]
#define REGA_ADDR_0711      0x11    // 2'h0, FASTLOCK_BW2_PLLD[5: 0]
#define REGA_ADDR_0712      0x12    // 2'h0, FASTLOCK_BW3_PLLD[5: 0]
#define REGA_ADDR_0713      0x13    // 2'h0, FASTLOCK_BW4_PLLD[5: 0]
#define REGA_ADDR_0714      0x14    // 2'h0, FASTLOCK_BW5_PLLD[5: 0]
#define REGA_ADDR_0715      0x15    // 7'h0, BW_UPDATE_PLLD
#define REGA_ADDR_0716      0x16    // M_NUM_PLLD[7:0  ]
#define REGA_ADDR_0717      0x17    // M_NUM_PLLD[15:8 ]
#define REGA_ADDR_0718      0x18    // M_NUM_PLLD[23:16]
#define REGA_ADDR_0719      0x19    // M_NUM_PLLD[31:24]
#define REGA_ADDR_071A      0x1A    // M_NUM_PLLD[39:32]
#define REGA_ADDR_071B      0x1B    // M_NUM_PLLD[47:40]
#define REGA_ADDR_071C      0x1C    // M_NUM_PLLD[55:48]
#define REGA_ADDR_071D      0x1D    // M_DEN_PLLD[7:0  ]
#define REGA_ADDR_071E      0x1E    // M_DEN_PLLD[15:8 ]
#define REGA_ADDR_071F      0x1F    // M_DEN_PLLD[23:16]
#define REGA_ADDR_0720      0x20    // M_DEN_PLLD[31:24]
#define REGA_ADDR_0721      0x21    // 7'h0, M_UPDATE_PLLD
#define REGA_ADDR_0722      0x22    // 3'h1, M_FRAC_EN_PLLD, M_FRAC_MODE_PLLD[3: 0] // 5 R/W Reserved Must be set to 1 for DSPLL D
#define REGA_ADDR_0723      0x23    // 6'h0, M_FSTEPW_DEN_PLLD, M_FSTEP_MSK_PLLD
#define REGA_ADDR_0724      0x24    // M_FSTEPW_PLLD[7:0  ]
#define REGA_ADDR_0725      0x25    // M_FSTEPW_PLLD[15:8 ]
#define REGA_ADDR_0726      0x26    // M_FSTEPW_PLLD[23:16]
#define REGA_ADDR_0727      0x27    // M_FSTEPW_PLLD[31:24]
#define REGA_ADDR_0728      0x28    // M_FSTEPW_PLLD[39:32]
#define REGA_ADDR_0729      0x29    // M_FSTEPW_PLLD[47:40]
#define REGA_ADDR_072A      0x2A    // M_FSTEPW_PLLD[55:48]
#define REGA_ADDR_072B      0x2B    // 5'h0, IN_SEL_PLLD[2: 0]
#define REGA_ADDR_072C      0x2C    // 6'h0, FASTLOCK_MAN_PLLD, FASTLOCK_AUTO_EN_PLLD
#define REGA_ADDR_072D      0x2D    // RAMP_STEP_INTERVAL_PLLD[2: 0], HOLDEXIT_BW_SEL1_PLLD, HOLD_RAMP_BYP_PLLD, 2'h3, HOLD_EN_PLLD
#define REGA_ADDR_072F      0x2F    // 3'h0, HOLD_HIST_LEN_PLLD[3: 0]
#define REGA_ADDR_0730      0x30    // 3'h0, HOLD_HIST_DELAY_PLLD[3: 0]
#define REGA_ADDR_0733      0x33    // HOLD_15M_CYC_COUNT_PLLD[7:0  ]
#define REGA_ADDR_0734      0x34    // HOLD_15M_CYC_COUNT_PLLD[15:8 ]
#define REGA_ADDR_0735      0x35    // HOLD_15M_CYC_COUNT_PLLD[23:16]
#define REGA_ADDR_0736      0x36    // 7'h0, FORCE_HOLD_PLLD
#define REGA_ADDR_0737      0x37    // 5'h0, HSW_EN_PLLD, CLK_SWITCH_MODE_PLLD[1: 0]
#define REGA_ADDR_073B      0x3B    // 4'h0, HSW_PHMEAS_CTRL_PLLD[1: 0], HSW_MODE_PLLD[1: 0]
#define REGA_ADDR_073C      0x3C    // HSW_PHMEAS_THR_PLLD[7: 0]
#define REGA_ADDR_073D      0x3D    // 6'h0, HSW_PHMEAS_THR_PLLD [9: 8]
#define REGA_ADDR_073E      0x3E    // 3'h0, HSW_COARSE_PM_LEN_PLLD[4: 0]
#define REGA_ADDR_073F      0x3F    // 3'h0, HSW_COARSE_PM_DLY_PLLD[4: 0]
#define REGA_ADDR_0788      0x88    // 4'h0, HSW_FINE_PM_LEN_PLLD[3: 0]
#define REGA_ADDR_0789      0x89    // PFD_EN_DELAY_PLLD[7:0 ]
#define REGA_ADDR_078A      0x8A    // 3'h0, PFD_EN_DELAY_PLLD[12:8]
#define REGA_ADDR_078B      0x8B    // HSW_MEAS_SETTLE_PLLD[7:0  ]
#define REGA_ADDR_078C      0x8C    // HSW_MEAS_SETTLE_PLLD[15:8 ]
#define REGA_ADDR_078D      0x8D    // 4'h0, HSW_MEAS_SETTLE_PLLD[19:16]
#define REGA_ADDR_079B      0x9B    /*
                                     HOLDEXIT_STD_BO_PLLD,
                                     HOLDEXIT_BW_SEL0_PLLD,
                                     HOLD_FRZ_WITH_INTONLY_PLLD,
                                     HOLD_PRESERVE_HIST_PLLD,
                                     1'b1,
                                     HO_SKIP_PHASE_PLLD,
                                     INIT_LP_CLOSE_HO_PLLD,
                                     1'b0
                                     */
#define REGA_ADDR_079C      0x9C    // HOLD_RAMPBP_NOHIST_PLLD, HOLDEXIT_ST_BO_PLLD, 2'h0, 4'hc
#define REGA_ADDR_079D      0x9D    // 2'h0, HOLDEXIT_BW0_PLLD[5: 0]
#define REGA_ADDR_079E      0x9E    // 2'h0, HOLDEXIT_BW1_PLLD[5: 0]
#define REGA_ADDR_079F      0x9F    // 2'h0, HOLDEXIT_BW2_PLLD[5: 0]
#define REGA_ADDR_07A0      0xA0    // 2'h0, HOLDEXIT_BW3_PLLD[5: 0]
#define REGA_ADDR_07A1      0xA1    // 2'h0, HOLDEXIT_BW4_PLLD[5: 0]
#define REGA_ADDR_07A2      0xA2    // 2'h0, HOLDEXIT_BW5_PLLD[5: 0]
#define REGA_ADDR_07A4      0xA4    // HSW_LIMIT_PLLD[7: 0]
#define REGA_ADDR_07A5      0xA5    // 7'h0, HSW_LIMIT_ACTION_PLLD
#define REGA_ADDR_07A6      0xA6    // 4'h0, RAMP_SWITCH_EN_PLLD, RAMP_STEP_SIZE_PLLD[2: 0]
#define REGA_ADDR_07AC      0xAC    // 4'h0, HOLD_SETTLE_DEN_EN_DSPLLD, 2'h0, OUT_MAX_LIMIT_EN_PLLD
#define REGA_ADDR_07AD      0xAD    // OUT_MAX_LIMIT_LMT_PLLD[7:0 ]
#define REGA_ADDR_07AE      0xAE    // OUT_MAX_LIMIT_LMT_PLLD[15:8]
#define REGA_ADDR_07B1      0xB1    // HOLD_SETTLE_TARGET_DSPLLD[7:0 ]
#define REGA_ADDR_07B2      0xB2    // HOLD_SETTLE_TARGET_DSPLLD[15:8]
#define REGA_ADDR_0822      0x22    // FIXREGSD10[7: 0]
#define REGA_ADDR_0831      0x31    // FIXREGSD15[7: 0]
#define REGA_ADDR_090E      0x0E    // 7'h1, XAXB_EXTCLK_EN // Selects between the XTAL or external reference clock on the XA/XB pins. Default is 0, XTAL. Set to 1 to use an external reference oscillator.
#define REGA_ADDR_0949      0x49    // IN_PULSED_CMOS_EN[3: 0], IN_EN[3: 0] // IN_PULSED_CMOS_EN: 0: Standard Input Format; 1: Pulsed CMOS Input Format for IN3�N0. See for more information.  // IN_EN: 0: Disable and Powerdown Input Buffer; 1: Enable Input Buffer; for in0~3
#define REGA_ADDR_094A      0x4A    // 4'h0, INX_TO_PFD_EN[3: 0]
#define REGA_ADDR_0B44      0x44    // FRACN_CLK_DIS_PLLD, FRACN_CLK_DIS_PLLC, FRACN_CLK_DIS_PLLB, FRACN_CLK_DIS_PLLA, PDIV_FRACN_CLK_DIS[3: 0]
#define REGA_ADDR_0B47      0x47    // 3'h0, OOF_CLK_DIS[4: 0]
#define REGA_ADDR_0B48      0x48    // 3'h0, OOF_DIV_CLK_DIS[4: 0]
#define REGA_ADDR_0C03      0x03    // 4'h0, IN_CLK_VAL_PWR_UP_DIS[3: 0]
#define REGA_ADDR_0C09      0x09    // 7'h0, IN_CLK_VAL_EN_PLLC
#define REGA_ADDR_0C0A      0x0A    // IN_CLK_VAL_TIME_PLLC[7: 0]
#define REGA_ADDR_0C0B      0x0B    // 7'h0, IN_CLK_VAL_EN_PLLD
#define REGA_ADDR_0C0C      0x0C    // IN_CLK_VAL_TIME_PLLD[7: 0]

//////////////////////////////////////////////////
/////////REGA  Value///////////////////////////////
#define OOF_INTR_MSK      0
#define LOS_INTR_MSK      0
#define HOLD_INTR_MSK_PLLA      1
#define HOLD_INTR_MSK_PLLB      1
#define HOLD_INTR_MSK_PLLC      0
#define HOLD_INTR_MSK_PLLD      0
#define LOL_INTR_MSK_PLLA      1
#define LOL_INTR_MSK_PLLB      1
#define LOL_INTR_MSK_PLLC      0
#define LOL_INTR_MSK_PLLD      0
#define CAL_INTR_MSK_PLLA      1
#define CAL_INTR_MSK_PLLB      1
#define CAL_INTR_MSK_PLLC      0
#define CAL_INTR_MSK_PLLD      0
#define LOSXAXB_DIS      0
#define LOS_EN      15 //3
#define LOS0_TRG_THR      114
#define LOS1_TRG_THR      114
#define LOS2_TRG_THR      114
#define LOS3_TRG_THR      114
#define LOS0_CLR_THR      2
#define LOS1_CLR_THR      2
#define LOS_MIN_PERIOD_EN      15
#define FAST_OOF_EN      15
#define OOF_EN      15
#define LOS2_CLR_THR      2
#define LOS3_CLR_THR      2
#define OOF_REF_SEL      4
#define OOF0_DIV_SEL      11
#define OOF1_DIV_SEL      11
#define OOF2_DIV_SEL      11
#define OOF3_DIV_SEL      10
#define OOF0_SET_THR      50
#define OOF1_SET_THR      50
#define OOF2_SET_THR      50
#define OOF3_SET_THR      50
#define OOF0_CLR_THR      50
#define OOF1_CLR_THR      50
#define OOF2_CLR_THR      50
#define OOF3_CLR_THR      50
#define OOF0_DETWIN_SEL      5
#define OOF1_DETWIN_SEL      5
#define OOF2_DETWIN_SEL      5
#define OOF3_DETWIN_SEL      5
#define OOF_ON_LOS      15
#define FAST_OOF0_SET_THR      3
#define FAST_OOF1_SET_THR      3
#define FAST_OOF2_SET_THR      3
#define FAST_OOF3_SET_THR      3
#define FAST_OOF0_CLR_THR      3
#define FAST_OOF1_CLR_THR      3
#define FAST_OOF2_CLR_THR      3
#define FAST_OOF3_CLR_THR      3
#define FAST_OOF0_DETWIN_SEL      1
#define FAST_OOF1_DETWIN_SEL      1
#define FAST_OOF2_DETWIN_SEL      1
#define FAST_OOF3_DETWIN_SEL      1
#define OOF0_RATIO_REF 	      21474836ul
#define OOF1_RATIO_REF	      21845333ul
#define OOF2_RATIO_REF      21474836ul
#define OOF3_RATIO_REF      13981013ul
#define LOL_FST_EN_PLLA      0
#define LOL_FST_EN_PLLB      0
#define LOL_SLOW_EN_PLLA      0
#define LOL_SLOW_EN_PLLB      0
#define LOL_SLW_VALWIN_SEL_PLLA      0
#define LOL_SLW_VALWIN_SEL_PLLB      0
#define LOL_SLW_VALWIN_SEL_PLLC      0
#define LOL_SLW_VALWIN_SEL_PLLD      0
#define LOL_SLW_VALWIN_SEL_PLLA      0
#define LOL_SLW_VALWIN_SEL_PLLB      0
#define LOL_SLW_VALWIN_SEL_PLLC      0
#define LOL_SLW_VALWIN_SEL_PLLD      0

#define OUT0_PDN      0
#define OUT0_OE       1
#define OUT0_MUX_SEL      2 //<-----OUT0 SEL
#define OUT0_VDD_SEL      1
#define OUT0_VDD_SEL_EN      1
#define OUT0_INV      0
#define OUT2_PDN      0
#define OUT2_OE      1
#define OUT2_RDIV_FORCE2      1
#define OUT2_MUX_SEL      0 //<-----OUT2 SEL
#define OUT2_VDD_SEL      1
#define OUT2_VDD_SEL_EN      1
#define OUT2_INV      0
#define OUT4_PDN      0
#define OUT4_OE      1
#define OUT4_MUX_SEL      3 //<-----OUT4 SEL
#define OUT4_VDD_SEL      1
#define OUT4_VDD_SEL_EN      1
#define OUT4_INV      0
#define OUT6_PDN      0
#define OUT6_OE      1
#define OUT6_RDIV_FORCE2      1
#define OUT6_MUX_SEL      1 //<-----OUT6 SEL
#define OUT6_VDD_SEL      1
#define OUT6_VDD_SEL_EN      1
#define OUT6_INV      0
#define OUT7_PDN      0
//#define OUT7_OE = XCVR_REFCLK_RSV ;// 1 ;
#define OUT7_RDIV_FORCE2      1
#define OUT7_MUX_SEL      1 //<-----OUT7 SEL
#define OUT7_VDD_SEL      1
#define OUT7_VDD_SEL_EN      1
#define OUT7_INV      0

#define PXAXB      0  // The divider value for the XAXB input
#define P0_NUM      768ull  //--300h
#define P0_DEN      25ul
#define P1_NUM      125ull
#define P1_DEN      4ul
#define P2_NUM      768ull
#define P2_DEN      25ul
#define P3_NUM      10ull
#define P3_DEN      1ul
#define P0_UPDATE      1  //0// - No update for P-divider value
#define P1_UPDATE      1  //1// - Update P-divider value
#define P2_UPDATE      1
#define P3_UPDATE      1
#define P0_FRACN_MODE      11
#define P0_FRACN_EN      1
#define P1_FRACN_MODE      11
#define P1_FRACN_EN      1
#define P2_FRACN_MODE      11
#define P2_FRACN_EN      1
#define P3_FRACN_MODE      11
#define P3_FRACN_EN      0
#define M_NUM      633507676160ull
#define M_DEN      2147483648ul
#define MXAXB_UPDATE      1   //Set to 1 to update the MXAXB_NUM and//MXAXB_DEN values. A SOFT_RST may also be//used to update these values.
#define R2_REG      0ul
#define R6_REG      0ul
#define R7_REG      0ul
#define OOF_STOP_ON_LOS      15
#define OOF_CLEAR_ON_LOS      15
#define LOL_SLW_VALWIN_SELX_PLLA      0
#define LOL_SLW_VALWIN_SELX_PLLB      0
#define FASTLOCK_DLY_ONSW_EN_PLLA      0
#define FASTLOCK_DLY_ONSW_EN_PLLB      0
#define FASTLOCK_DLY_ONLOL_EN_PLLA      0
#define FASTLOCK_DLY_ONLOL_EN_PLLB      0

#define N0_DEN      2147483648ul
#define N0_UPDATE      1
#define N1_DEN      2147483648ul
#define N1_UPDATE      1
#define N2_UPDATE      1
#define N3_UPDATE      1
#define N_UPDATE      1 //Writing a 1 to this bit will update all DSPLL internal divider values. When this bit is written, all other bits in this//register must be written as zeros.

#define M_UPDATE_PLLA      1  //  Must write a 1 to this bit to cause the individual M divider//changes to take effect. Note that a corresponding//SOFT_RST_PLLx or device SOFT_RST will also update//the M divider values.

#define M_UPDATE_PLLB      1

#define BW_UPDATE_PLLC      1
#define M_UPDATE_PLLC      1
#define M_FRAC_MODE_PLLC      11
#define M_FSTEP_MSK_PLLC      1
#define M_FSTEPW_DEN_PLLC      0
#define M_FSTEPW_PLLC      0ull
#define FASTLOCK_AUTO_EN_PLLC      1
#define FASTLOCK_MAN_PLLC      0
#define HOLD_EN_PLLC      1
#define HOLDEXIT_BW_SEL1_PLLC      0
#define HSW_EN_PLLC      1
#define HSW_MODE_PLLC      1
#define HSW_PHMEAS_CTRL_PLLC      0
#define HSW_PHMEAS_THR_PLLC      3
#define HOLDEXIT_STD_BO_PLLC      0
#define HOLD_PRESERVE_HIST_PLLC      1
#define HO_SKIP_PHASE_PLLC      0
#define INIT_LP_CLOSE_HO_PLLC      0
#define HOLDEXIT_ST_BO_PLLC      0
#define HSW_LIMIT_ACTION_PLLC      0
#define RAMP_SWITCH_EN_PLLC      0

#define BW_UPDATE_PLLD      1
#define M_UPDATE_PLLD      1
#define M_FRAC_MODE_PLLD      11
#define M_FSTEP_MSK_PLLD      1
#define M_FSTEPW_DEN_PLLD      0
#define M_FSTEPW_PLLD      0ull
#define FASTLOCK_AUTO_EN_PLLD      1
#define FASTLOCK_MAN_PLLD      0
#define HOLD_EN_PLLD      1
#define HOLDEXIT_BW_SEL1_PLLD      0
#define HSW_EN_PLLD      1
#define HSW_MODE_PLLD      1
#define HSW_PHMEAS_CTRL_PLLD      0
#define HSW_PHMEAS_THR_PLLD      3
#define HOLDEXIT_STD_BO_PLLD      0
#define HOLD_PRESERVE_HIST_PLLD      1
#define HO_SKIP_PHASE_PLLD      0
#define INIT_LP_CLOSE_HO_PLLD      0
#define HOLDEXIT_ST_BO_PLLD      0
#define HSW_LIMIT_ACTION_PLLD      0
#define RAMP_SWITCH_EN_PLLD      0


#define XAXB_EXTCLK_EN      1 //de10_agiex  //Selects between the XTAL or external reference cloc//on the XA/XB pins. Default is 0, XTAL. Set to 1 to use//an external reference oscillator.
#define IN_EN      15 // ( (IO0_CLK == `IO_50M) &  (IO1_CLK == `IO_50M)) ?0:  15   ; //0: Disable and Powerdown Input Buffer //and free run  //1: enable  Input Buffer//for in0~3
#define IN_PULSED_CMOS_EN      0  // 0: Standard Input Format//1: Pulsed CMOS Input Format for IN3 See for//more information
#define INX_TO_PFD_EN      15

#define PDIV_FRACN_CLK_DIS      8
#define FRACN_CLK_DIS_PLLA      0
#define FRACN_CLK_DIS_PLLB      0
#define OOF_CLK_DIS      0
#define OOF_DIV_CLK_DIS      0

#define REG_0018  ((OOF_INTR_MSK & 0xf) << 4) | ((LOS_INTR_MSK & 0xf) << 0)
#define REG_0019  ((HOLD_INTR_MSK_PLLD & 0x1) << 7) | ((HOLD_INTR_MSK_PLLC & 0x1) << 6) | ((HOLD_INTR_MSK_PLLB & 0x1) << 5) | ((HOLD_INTR_MSK_PLLA & 0x1) << 4) | ((LOL_INTR_MSK_PLLD & 0x1) << 3) | ((LOL_INTR_MSK_PLLC & 0x1) << 2) | ((LOL_INTR_MSK_PLLB & 0x1) << 1) | ((LOL_INTR_MSK_PLLA & 0x1) << 0)
#define REG_001A  ((CAL_INTR_MSK_PLLD & 0x1) << 7) | ((CAL_INTR_MSK_PLLC & 0x1) << 6) | ((CAL_INTR_MSK_PLLB & 0x1) << 5) | ((CAL_INTR_MSK_PLLA & 0x1) << 4)
#define REG_002C  ((LOSXAXB_DIS & 0x1) << 4) | ((LOS_EN & 0xf) << 0)
#define REG_002E  (LOS0_TRG_THR >> 0 & 0xff)
#define REG_002F  (LOS0_TRG_THR >> 8 & 0xff)
#define REG_0030  (LOS1_TRG_THR >> 0 & 0xff)
#define REG_0031  (LOS1_TRG_THR >> 8 & 0xff)
#define REG_0032  (LOS2_TRG_THR >> 0 & 0xff)
#define REG_0033  (LOS2_TRG_THR >> 8 & 0xff)
#define REG_0034  (LOS3_TRG_THR >> 0 & 0xff)
#define REG_0035  (LOS3_TRG_THR >> 8 & 0xff)
#define REG_0036  (LOS0_CLR_THR >> 0 & 0xff)
#define REG_0037  (LOS0_CLR_THR >> 8 & 0xff)
#define REG_0038  (LOS1_CLR_THR >> 0 & 0xff)
#define REG_0039  (LOS1_CLR_THR >> 8 & 0xff)
#define REG_003A  (LOS2_CLR_THR >> 0 & 0xff)
#define REG_003B  (LOS2_CLR_THR >> 8 & 0xff)
#define REG_003C  (LOS3_CLR_THR >> 0 & 0xff)
#define REG_003D  (LOS3_CLR_THR >> 8 & 0xff)
#define REG_003E  ((LOS_MIN_PERIOD_EN & 0xf) << 4)
#define REG_003F  ((FAST_OOF_EN & 0xf) << 4) | ((OOF_EN & 0xf) << 0)
#define REG_0040  ((OOF_REF_SEL & 0x7) << 0)
#define REG_0041  ((OOF0_DIV_SEL & 0x1f) << 0)
#define REG_0042  ((OOF1_DIV_SEL & 0x1f) << 0)
#define REG_0043  ((OOF2_DIV_SEL & 0x1f) << 0)
#define REG_0044  ((OOF3_DIV_SEL & 0x1f) << 0)
#define REG_0046  ((OOF0_SET_THR & 0xff) << 0)
#define REG_0047  ((OOF1_SET_THR & 0xff) << 0)
#define REG_0048  ((OOF2_SET_THR & 0xff) << 0)
#define REG_0049  ((OOF3_SET_THR & 0xff) << 0)
#define REG_004A  ((OOF0_CLR_THR & 0xff) << 0)
#define REG_004B  ((OOF1_CLR_THR & 0xff) << 0)
#define REG_004C  ((OOF2_CLR_THR & 0xff) << 0)
#define REG_004D  ((OOF3_CLR_THR & 0xff) << 0)
#define REG_004E  ((OOF1_DETWIN_SEL & 0x7) << 4) | ((OOF0_DETWIN_SEL & 0x7) << 0)
#define REG_004F  ((OOF3_DETWIN_SEL & 0x7) << 4) | ((OOF2_DETWIN_SEL & 0x7) << 0)
#define REG_0050  ((OOF_ON_LOS & 0xf) << 0)
#define REG_0051  ((FAST_OOF0_SET_THR & 0xf) << 0)
#define REG_0052  ((FAST_OOF1_SET_THR & 0xf) << 0)
#define REG_0053  ((FAST_OOF2_SET_THR & 0xf) << 0)
#define REG_0054  ((FAST_OOF3_SET_THR & 0xf) << 0)
#define REG_0055  ((FAST_OOF0_CLR_THR & 0xf) << 0)
#define REG_0056  ((FAST_OOF1_CLR_THR & 0xf) << 0)
#define REG_0057  ((FAST_OOF2_CLR_THR & 0xf) << 0)
#define REG_0058  ((FAST_OOF3_CLR_THR & 0xf) << 0)
#define REG_0059  ((FAST_OOF3_DETWIN_SEL & 0x3) << 6) | ((FAST_OOF2_DETWIN_SEL & 0x3) << 4) | ((FAST_OOF1_DETWIN_SEL & 0x3) << 2) | ((FAST_OOF0_DETWIN_SEL & 0x3) << 0)
#define REG_005A  (OOF0_RATIO_REF >> 0 & 0xff)
#define REG_005B  (OOF0_RATIO_REF >> 8 & 0xff)
#define REG_005C  (OOF0_RATIO_REF >> 16 & 0xff)
#define REG_005D  (OOF0_RATIO_REF >> 24 & 0x3)
#define REG_005E  (OOF1_RATIO_REF >> 0 & 0xff)
#define REG_005F  (OOF1_RATIO_REF >> 8 & 0xff)
#define REG_0060  (OOF1_RATIO_REF >> 16 & 0xff)
#define REG_0061  (OOF1_RATIO_REF >> 24 & 0x3)
#define REG_0062  (OOF2_RATIO_REF >> 0 & 0xff)
#define REG_0063  (OOF2_RATIO_REF >> 8 & 0xff)
#define REG_0064  (OOF2_RATIO_REF >> 16 & 0xff)
#define REG_0065  (OOF2_RATIO_REF >> 24 & 0x3)
#define REG_0066  (OOF3_RATIO_REF >> 0 & 0xff)
#define REG_0067  (OOF3_RATIO_REF >> 8 & 0xff)
#define REG_0068  (OOF3_RATIO_REF >> 16 & 0xff)
#define REG_0069  (OOF3_RATIO_REF >> 24 & 0x3)
#define REG_0092  ((LOL_FST_EN_PLLD & 0x1) << 3) | ((LOL_FST_EN_PLLC & 0x1) << 2) | ((LOL_FST_EN_PLLB & 0x1) << 1) | ((LOL_FST_EN_PLLA & 0x1) << 0)
#define REG_0094  ((LOL_FST_DETWIN_SEL_PLLD & 0xf) << 4) | ((LOL_FST_DETWIN_SEL_PLLC & 0xf) << 0)
#define REG_0097  ((LOL_FST_SET_THR_SEL_PLLD & 0xf) << 4) | ((LOL_FST_SET_THR_SEL_PLLC & 0xf) << 0)
#define REG_0099  ((LOL_FST_CLR_THR_SEL_PLLD & 0xf) << 4) | ((LOL_FST_CLR_THR_SEL_PLLC & 0xf) << 0)
#define REG_009A  ((LOL_SLOW_EN_PLLD & 0x1) << 3) | ((LOL_SLOW_EN_PLLC & 0x1) << 2) | ((LOL_SLOW_EN_PLLB & 0x1) << 1) | ((LOL_SLOW_EN_PLLA & 0x1) << 0)
#define REG_009C  ((LOL_SLW_DETWIN_SEL_PLLD & 0xf) << 4) | ((LOL_SLW_DETWIN_SEL_PLLC & 0xf) << 0)
#define REG_009D  ((LOL_SLW_VALWIN_SEL_PLLD & 0x3) << 6) | ((LOL_SLW_VALWIN_SEL_PLLC & 0x3) << 4) | ((LOL_SLW_VALWIN_SEL_PLLB & 0x3) << 2) | ((LOL_SLW_VALWIN_SEL_PLLA & 0x3) << 0)
#define REG_009F  ((LOL_SLW_SET_THR_PLLD & 0xf) << 4) | ((LOL_SLW_SET_THR_PLLC & 0xf) << 0)
#define REG_00A1  ((LOL_SLW_CLR_THR_PLLD & 0xf) << 4) | ((LOL_SLW_CLR_THR_PLLC & 0xf) << 0)
#define REG_00AE  (LOL_CLR_DELAY_DIV256_PLLC >> 0 & 0xff)
#define REG_00AF  (LOL_CLR_DELAY_DIV256_PLLC >> 8 & 0xff)
#define REG_00B0  (LOL_CLR_DELAY_DIV256_PLLC >> 16 & 0xff)
#define REG_00B1  (LOL_CLR_DELAY_DIV256_PLLC >> 24 & 0x1f)
#define REG_00B3  (LOL_CLR_DELAY_DIV256_PLLD >> 0 & 0xff)
#define REG_00B4  (LOL_CLR_DELAY_DIV256_PLLD >> 8 & 0xff)
#define REG_00B5  (LOL_CLR_DELAY_DIV256_PLLD >> 16 & 0xff)
#define REG_00B6  (LOL_CLR_DELAY_DIV256_PLLD >> 24 & 0x1f)
#define REG_00EE  (FASTLOCK_EXTEND_PLLC >> 0 & 0xff)
#define REG_00EF  (FASTLOCK_EXTEND_PLLC >> 8 & 0xff)
#define REG_00F0  (FASTLOCK_EXTEND_PLLC >> 16 & 0xff)
#define REG_00F1  (FASTLOCK_EXTEND_PLLC >> 24 & 0x1f)
#define REG_00F2  (FASTLOCK_EXTEND_PLLD >> 0 & 0xff)
#define REG_00F3  (FASTLOCK_EXTEND_PLLD >> 8 & 0xff)
#define REG_00F4  (FASTLOCK_EXTEND_PLLD >> 16 & 0xff)
#define REG_00F5  (FASTLOCK_EXTEND_PLLD >> 24 & 0x1f)
#define REG_0108  ((OUT0_RDIV_FORCE2 & 0x1) << 2) | ((OUT0_OE & 0x1) << 1) | ((OUT0_PDN & 0x1) << 0)
#define REG_010B  ((OUT0_INV & 0x3) << 6) | ((OUT0_VDD_SEL & 0x3) << 4) | ((OUT0_VDD_SEL_EN & 0x1) << 3) | ((OUT0_MUX_SEL & 0x7) << 0)
#define REG_0117  ((OUT2_RDIV_FORCE2 & 0x1) << 2) | ((OUT2_OE & 0x1) << 1) | ((OUT2_PDN & 0x1) << 0)
#define REG_011A  ((OUT2_INV & 0x3) << 6) | ((OUT2_VDD_SEL & 0x3) << 4) | ((OUT2_VDD_SEL_EN & 0x1) << 3) | ((OUT2_MUX_SEL & 0x7) << 0)
#define REG_0126  ((OUT4_RDIV_FORCE2 & 0x1) << 2) | ((OUT4_OE & 0x1) << 1) | ((OUT4_PDN & 0x1) << 0)
#define REG_0129  ((OUT4_INV & 0x3) << 6) | ((OUT4_VDD_SEL & 0x3) << 4) | ((OUT4_VDD_SEL_EN & 0x1) << 3) | ((OUT4_MUX_SEL & 0x7) << 0)
#define REG_0130  ((OUT6_RDIV_FORCE2 & 0x1) << 2) | ((OUT6_OE & 0x1) << 1) | ((OUT6_PDN & 0x1) << 0)
#define REG_0133  ((OUT6_INV & 0x3) << 6) | ((OUT6_VDD_SEL & 0x3) << 4) | ((OUT6_VDD_SEL_EN & 0x1) << 3) | ((OUT6_MUX_SEL & 0x7) << 0)
#define REG_013A  ((OUT7_RDIV_FORCE2 & 0x1) << 2) | ((OUT7_OE & 0x1) << 1) | ((OUT7_PDN & 0x1) << 0)
#define REG_013D  ((OUT7_INV & 0x3) << 6) | ((OUT7_VDD_SEL & 0x3) << 4) | ((OUT7_VDD_SEL_EN & 0x1) << 3) | ((OUT7_MUX_SEL & 0x7) << 0)
#define REG_0206  ((PXAXB & 0x3) << 0)
#define REG_0208  (P0_NUM >> 0 & 0xff)
#define REG_0209  (P0_NUM >> 8 & 0xff)
#define REG_020A  (P0_NUM >> 16 & 0xff)
#define REG_020B  (P0_NUM >> 24 & 0xff)
#define REG_020C  (P0_NUM >> 32 & 0xff)
#define REG_020D  (P0_NUM >> 40 & 0xff)
#define REG_020E  (P0_DEN >> 0 & 0xff)
#define REG_020F  (P0_DEN >> 8 & 0xff)
#define REG_0210  (P0_DEN >> 16 & 0xff)
#define REG_0211  (P0_DEN >> 24 & 0xff)
#define REG_0212  (P1_NUM >> 0 & 0xff)
#define REG_0213  (P1_NUM >> 8 & 0xff)
#define REG_0214  (P1_NUM >> 16 & 0xff)
#define REG_0215  (P1_NUM >> 24 & 0xff)
#define REG_0216  (P1_NUM >> 32 & 0xff)
#define REG_0217  (P1_NUM >> 40 & 0xff)
#define REG_0218  (P1_DEN >> 0 & 0xff)
#define REG_0219  (P1_DEN >> 8 & 0xff)
#define REG_021A  (P1_DEN >> 16 & 0xff)
#define REG_021B  (P1_DEN >> 24 & 0xff)
#define REG_021C  (P2_NUM >> 0 & 0xff)
#define REG_021D  (P2_NUM >> 8 & 0xff)
#define REG_021E  (P2_NUM >> 16 & 0xff)
#define REG_021F  (P2_NUM >> 24 & 0xff)
#define REG_0220  (P2_NUM >> 32 & 0xff)
#define REG_0221  (P2_NUM >> 40 & 0xff)
#define REG_0222  (P2_DEN >> 0 & 0xff)
#define REG_0223  (P2_DEN >> 8 & 0xff)
#define REG_0224  (P2_DEN >> 16 & 0xff)
#define REG_0225  (P2_DEN >> 24 & 0xff)
#define REG_0226  (P3_NUM >> 0 & 0xff)
#define REG_0227  (P3_NUM >> 8 & 0xff)
#define REG_0228  (P3_NUM >> 16 & 0xff)
#define REG_0229  (P3_NUM >> 24 & 0xff)
#define REG_022A  (P3_NUM >> 32 & 0xff)
#define REG_022B  (P3_NUM >> 40 & 0xff)
#define REG_022C  (P3_DEN >> 0 & 0xff)
#define REG_022D  (P3_DEN >> 8 & 0xff)
#define REG_022E  (P3_DEN >> 16 & 0xff)
#define REG_022F  (P3_DEN >> 24 & 0xff)
#define REG_0230  ((P3_UPDATE & 0x1) << 3) | ((P2_UPDATE & 0x1) << 2) | ((P1_UPDATE & 0x1) << 1) | ((P0_UPDATE & 0x1) << 0)
#define REG_0231  ((P0_FRACN_EN & 0x1) << 4) | ((P0_FRACN_MODE & 0xf) << 0)
#define REG_0232  ((P1_FRACN_EN & 0x1) << 4) | ((P1_FRACN_MODE & 0xf) << 0)
#define REG_0233  ((P2_FRACN_EN & 0x1) << 4) | ((P2_FRACN_MODE & 0xf) << 0)
#define REG_0234  ((P3_FRACN_EN & 0x1) << 4) | ((P3_FRACN_MODE & 0xf) << 0)
#define REG_0235  (M_NUM >> 0 & 0xff)
#define REG_0236  (M_NUM >> 8 & 0xff)
#define REG_0237  (M_NUM >> 16 & 0xff)
#define REG_0238  (M_NUM >> 24 & 0xff)
#define REG_0239  (M_NUM >> 32 & 0xff)
#define REG_023A  (M_NUM >> 40 & 0xf)
#define REG_023B  (M_DEN >> 0 & 0xff)
#define REG_023C  (M_DEN >> 8 & 0xff)
#define REG_023D  (M_DEN >> 16 & 0xff)
#define REG_023E  (M_DEN >> 24 & 0xff)
#define REG_023F  ((MXAXB_UPDATE & 0x1) << 0) //Set to 1 to update the MXAXB_NUM and//MXAXB_DEN values. A SOFT_RST may also be//used to update these values.
#define REG_024A  (R0_REG >> 0 & 0xff)
#define REG_024B  (R0_REG >> 8 & 0xff)
#define REG_024C  (R0_REG >> 16 & 0xff)
#define REG_0253  (R2_REG >> 0 & 0xff)
#define REG_0254  (R2_REG >> 8 & 0xff)
#define REG_0255  (R2_REG >> 16 & 0xff)
#define REG_025C  (R4_REG >> 0 & 0xff)
#define REG_025D  (R4_REG >> 8 & 0xff)
#define REG_025E  (R4_REG >> 16 & 0xff)
#define REG_0262  (R6_REG >> 0 & 0xff)
#define REG_0263  (R6_REG >> 8 & 0xff)
#define REG_0264  (R6_REG >> 16 & 0xff)
#define REG_0268  (R7_REG >> 0 & 0xff)
#define REG_0269  (R7_REG >> 8 & 0xff)
#define REG_026A  (R7_REG >> 16 & 0xff)
#define REG_0292  ((OOF_STOP_ON_LOS & 0xf) << 0)
#define REG_0293  ((OOF_CLEAR_ON_LOS & 0xf) << 0)
#define REG_0295  ((FASTLOCK_EXTEND_SCL_PLLD & 0xf) << 4) | ((FASTLOCK_EXTEND_SCL_PLLC & 0xf) << 0)
#define REG_0296  ((LOL_SLW_VALWIN_SELX_PLLD & 0x1) << 3) | ((LOL_SLW_VALWIN_SELX_PLLC & 0x1) << 2) | ((LOL_SLW_VALWIN_SELX_PLLB & 0x1) << 1) | ((LOL_SLW_VALWIN_SELX_PLLA & 0x1) << 0)
#define REG_0297  ((FASTLOCK_DLY_ONSW_EN_PLLD & 0x1) << 3) | ((FASTLOCK_DLY_ONSW_EN_PLLC & 0x1) << 2) | ((FASTLOCK_DLY_ONSW_EN_PLLB & 0x1) << 1) | ((FASTLOCK_DLY_ONSW_EN_PLLA & 0x1) << 0)
#define REG_0299  ((FASTLOCK_DLY_ONLOL_EN_PLLD & 0x1) << 3) | ((FASTLOCK_DLY_ONLOL_EN_PLLC & 0x1) << 2) | ((FASTLOCK_DLY_ONLOL_EN_PLLB & 0x1) << 1) | ((FASTLOCK_DLY_ONLOL_EN_PLLA & 0x1) << 0)
#define REG_02A0  (FASTLOCK_DLY_ONLOL_PLLC >> 0 & 0xff)
#define REG_02A1  (FASTLOCK_DLY_ONLOL_PLLC >> 8 & 0xff)
#define REG_02A2  (FASTLOCK_DLY_ONLOL_PLLC >> 16 & 0xf)
#define REG_02A3  (FASTLOCK_DLY_ONLOL_PLLD >> 0 & 0xff)
#define REG_02A4  (FASTLOCK_DLY_ONLOL_PLLD >> 8 & 0xff)
#define REG_02A5  (FASTLOCK_DLY_ONLOL_PLLD >> 16 & 0xf)
#define REG_02AC  (FASTLOCK_DLY_ONSW_PLLC >> 0 & 0xff)
#define REG_02AD  (FASTLOCK_DLY_ONSW_PLLC >> 8 & 0xff)
#define REG_02AE  (FASTLOCK_DLY_ONSW_PLLC >> 16 & 0xf)
#define REG_02AF  (FASTLOCK_DLY_ONSW_PLLD >> 0 & 0xff)
#define REG_02B0  (FASTLOCK_DLY_ONSW_PLLD >> 8 & 0xff)
#define REG_02B1  (FASTLOCK_DLY_ONSW_PLLD >> 16 & 0xf)
#define REG_0302  (N0_NUM >> 0 & 0xff)
#define REG_0303  (N0_NUM >> 8 & 0xff)
#define REG_0304  (N0_NUM >> 16 & 0xff)
#define REG_0305  (N0_NUM >> 24 & 0xff)
#define REG_0306  (N0_NUM >> 32 & 0xff)
#define REG_0307  (N0_NUM >> 40 & 0xf)
#define REG_0308  (N0_DEN >> 0 & 0xff)
#define REG_0309  (N0_DEN >> 8 & 0xff)
#define REG_030A  (N0_DEN >> 16 & 0xff)
#define REG_030B  (N0_DEN >> 24 & 0xff)
#define REG_030C  ((N0_UPDATE & 0x1) << 0)
#define REG_030D  (N1_NUM >> 0 & 0xff)
#define REG_030E  (N1_NUM >> 8 & 0xff)
#define REG_030F  (N1_NUM >> 16 & 0xff)
#define REG_0310  (N1_NUM >> 24 & 0xff)
#define REG_0311  (N1_NUM >> 32 & 0xff)
#define REG_0312  (N1_NUM >> 40 & 0xf)
#define REG_0313  (N1_DEN >> 0 & 0xff)
#define REG_0314  (N1_DEN >> 8 & 0xff)
#define REG_0315  (N1_DEN >> 16 & 0xff)
#define REG_0316  (N1_DEN >> 24 & 0xff)
#define REG_0317  ((N1_UPDATE & 0x1) << 0)
#define REG_0318  (N2_NUM >> 0 & 0xff)
#define REG_0319  (N2_NUM >> 8 & 0xff)
#define REG_031A  (N2_NUM >> 16 & 0xff)
#define REG_031B  (N2_NUM >> 24 & 0xff)
#define REG_031C  (N2_NUM >> 32 & 0xff)
#define REG_031D  (N2_NUM >> 40 & 0xf)
#define REG_031E  (N2_DEN >> 0 & 0xff)
#define REG_031F  (N2_DEN >> 8 & 0xff)
#define REG_0320  (N2_DEN >> 16 & 0xff)
#define REG_0321  (N2_DEN >> 24 & 0xff)
#define REG_0322  ((N2_UPDATE & 0x1) << 0)
#define REG_0323  (N3_NUM >> 0 & 0xff)
#define REG_0324  (N3_NUM >> 8 & 0xff)
#define REG_0325  (N3_NUM >> 16 & 0xff)
#define REG_0326  (N3_NUM >> 24 & 0xff)
#define REG_0327  (N3_NUM >> 32 & 0xff)
#define REG_0328  (N3_NUM >> 40 & 0xf)
#define REG_0329  (N3_DEN >> 0 & 0xff)
#define REG_032A  (N3_DEN >> 8 & 0xff)
#define REG_032B  (N3_DEN >> 16 & 0xff)
#define REG_032C  (N3_DEN >> 24 & 0xff)
#define REG_032D  ((N3_UPDATE & 0x1) << 0)
#define REG_0338  ((N_UPDATE & 0x1) << 0) //Writing a 1 to this bit will update all DSPLL internal divider values. When this bit is written all other bits in this//register must be written as zeros.
#define REG_0420  ((M_UPDATE_PLLA & 0xf) << 0) // Must write a 1 to this bit to cause the individual M divider changes to take effect. Note that a corresponding SOFT_RST_PLLx or device SOFT_RST will also update the M divider values.
#define REG_0520  ((M_UPDATE_PLLB & 0xf) << 0)
#define REG_0608  ((BW0_PLLC & 0x3f) << 0)
#define REG_0609  ((BW1_PLLC & 0x3f) << 0)
#define REG_060A  ((BW2_PLLC & 0x3f) << 0)
#define REG_060B  ((BW3_PLLC & 0x3f) << 0)
#define REG_060C  ((BW4_PLLC & 0x3f) << 0)
#define REG_060D  ((BW5_PLLC & 0x3f) << 0)
#define REG_060E  ((FASTLOCK_BW0_PLLC & 0x3f) << 0)
#define REG_060F  ((FASTLOCK_BW1_PLLC & 0x3f) << 0)
#define REG_0610  ((FASTLOCK_BW2_PLLC & 0x3f) << 0)
#define REG_0611  ((FASTLOCK_BW3_PLLC & 0x3f) << 0)
#define REG_0612  ((FASTLOCK_BW4_PLLC & 0x3f) << 0)
#define REG_0613  ((FASTLOCK_BW5_PLLC & 0x3f) << 0)
#define REG_0614  ((BW_UPDATE_PLLC & 0x1) << 0)
#define REG_0615  (M_NUM_PLLC >> 0 & 0xff)
#define REG_0616  (M_NUM_PLLC >> 8 & 0xff)
#define REG_0617  (M_NUM_PLLC >> 16 & 0xff)
#define REG_0618  (M_NUM_PLLC >> 24 & 0xff)
#define REG_0619  (M_NUM_PLLC >> 32 & 0xff)
#define REG_061A  (M_NUM_PLLC >> 40 & 0xff)
#define REG_061B  (M_NUM_PLLC >> 48 & 0xff)
#define REG_061C  (M_DEN_PLLC >> 0 & 0xff)
#define REG_061D  (M_DEN_PLLC >> 8 & 0xff)
#define REG_061E  (M_DEN_PLLC >> 16 & 0xff)
#define REG_061F  (M_DEN_PLLC >> 24 & 0xff)
#define REG_0620  ((M_UPDATE_PLLC & 0x1) << 0)
#define REG_0621  ((1 & 0x1) << 5) | ((M_FRAC_EN_PLLC & 0x1) << 4) | ((M_FRAC_MODE_PLLC & 0xf) << 0) // bit 5 Must be set to 1 for DSPLL C
#define REG_0622  ((M_FSTEPW_DEN_PLLC & 0x1) << 1) |((M_FSTEP_MSK_PLLC & 0x1) << 0)
#define REG_0623  (M_FSTEPW_PLLC >> 0 & 0xff)
#define REG_0624  (M_FSTEPW_PLLC >> 8 & 0xff)
#define REG_0625  (M_FSTEPW_PLLC >> 16 & 0xff)
#define REG_0626  (M_FSTEPW_PLLC >> 24 & 0xff)
#define REG_0627  (M_FSTEPW_PLLC >> 32 & 0xff)
#define REG_0628  (M_FSTEPW_PLLC >> 40 & 0xff)
#define REG_0629  (M_FSTEPW_PLLC >> 48 & 0xff)
#define REG_062A  ((IN_SEL_PLLC & 0x7) << 0)
#define REG_062B  ((FASTLOCK_MAN_PLLC & 0x1) << 1) | ((FASTLOCK_AUTO_EN_PLLC & 0x1) << 0)
#define REG_062C  ((RAMP_STEP_INTERVAL_PLLC & 0x7) << 5) | ((HOLDEXIT_BW_SEL1_PLLC & 0x1) << 4) | ((HOLD_RAMP_BYP_PLLC & 0x1) << 3) | ((3 & 0x3) << 1) | ((HOLD_EN_PLLC & 0x1) << 0)
#define REG_062E  ((HOLD_HIST_LEN_PLLC & 0x1f) << 0)
#define REG_062F  ((HOLD_HIST_DELAY_PLLC & 0x1f) << 0)
#define REG_0632  (HOLD_15M_CYC_COUNT_PLLC >> 0 & 0xff)
#define REG_0633  (HOLD_15M_CYC_COUNT_PLLC >> 8 & 0xff)
#define REG_0634  (HOLD_15M_CYC_COUNT_PLLC >> 16 & 0xff)
#define REG_0635  ((FORCE_HOLD_PLLC & 0x1) << 0)
#define REG_0636  ((HSW_EN_PLLC & 0x1) << 2) | ((CLK_SWITCH_MODE_PLLC & 0x3) << 0)
#define REG_063A  ((HSW_PHMEAS_CTRL_PLLC & 0x3) << 0) | ((HSW_MODE_PLLC & 0x3) << 0)
#define REG_063B  (HSW_PHMEAS_THR_PLLC >> 0 & 0xff)
#define REG_063C  (HSW_PHMEAS_THR_PLLC >> 8 & 0x3)
#define REG_063D  ((HSW_COARSE_PM_LEN_PLLC & 0x1f) << 0)
#define REG_063E  ((HSW_COARSE_PM_DLY_PLLC & 0x1f) << 0)
#define REG_0688  ((HSW_FINE_PM_LEN_PLLC & 0xf) << 0)
#define REG_0689  (PFD_EN_DELAY_PLLC >> 0 & 0xff)
#define REG_068A  (PFD_EN_DELAY_PLLC >> 8 & 0x1f)
#define REG_068B  (HSW_MEAS_SETTLE_PLLC >> 0 & 0xff)
#define REG_068C  (HSW_MEAS_SETTLE_PLLC >> 8 & 0xff)
#define REG_068D  (HSW_MEAS_SETTLE_PLLC >> 16 & 0xf)
#define REG_069B  ((HOLDEXIT_STD_BO_PLLC & 0x1) << 7) | \
                  ((HOLDEXIT_BW_SEL0_PLLC & 0x1) << 6) | \
                  ((HOLD_FRZ_WITH_INTONLY_PLLC & 0x1) << 5) | \
                  ((HOLD_PRESERVE_HIST_PLLC & 0x1) << 4) | \
                  ((1 & 0x1) << 3) | \
                  ((HO_SKIP_PHASE_PLLC & 0x1) << 2) | \
                  ((INIT_LP_CLOSE_HO_PLLC & 0x1) << 1) | \
                  ((0 & 0x1) << 0)
#define REG_069C  ((HOLD_RAMPPB_NOHIST_PLLC & 0x1) << 7) | ((HOLDEXIT_ST_BO_PLLC & 0x1) << 6) | ((0x0c & 0x3f) << 0)
#define REG_069D  ((HOLDEXIT_BW0_PLLC & 0x3f) << 0)
#define REG_069E  ((HOLDEXIT_BW1_PLLC & 0x3f) << 0)
#define REG_069F  ((HOLDEXIT_BW2_PLLC & 0x3f) << 0)
#define REG_06A0  ((HOLDEXIT_BW3_PLLC & 0x3f) << 0)
#define REG_06A1  ((HOLDEXIT_BW4_PLLC & 0x3f) << 0)
#define REG_06A2  ((HOLDEXIT_BW5_PLLC & 0x3f) << 0)
#define REG_06A4  (HSW_LIMIT_PLLC >> 0 & 0xff)
#define REG_06A5  ((HSW_LIMIT_ACTION_PLLC & 0x1) << 0)
#define REG_06A6  ((RAMP_SWITCH_EN_PLLC & 0x1) << 3) | ((RAMP_STEP_SIZE_PLLC & 0x7) << 0)
#define REG_06AC  ((HOLD_SETTLE_DET_EN_DSPLLC & 0x1) << 3) | ((0x0 & 0x3) << 1) | ((OUT_MAX_LIMIT_EN_PLLC & 0x1) << 0)
#define REG_06AD  (OUT_MAX_LIMIT_LMT_DPSLLC >> 0 & 0xff)
#define REG_06AE  (OUT_MAX_LIMIT_LMT_DPSLLC >> 8 & 0xff)
#define REG_06B1  (HOLD_SETTLE_TARGET_DSPLLC >> 0 & 0xff)
#define REG_06B2  (HOLD_SETTLE_TARGET_DSPLLC >> 8 & 0xff)
#define REG_0709  ((BW0_PLLD & 0x3f) << 0)
#define REG_070A  ((BW1_PLLD & 0x3f) << 0)
#define REG_070B  ((BW2_PLLD & 0x3f) << 0)
#define REG_070C  ((BW3_PLLD & 0x3f) << 0)
#define REG_070D  ((BW4_PLLD & 0x3f) << 0)
#define REG_070E  ((BW5_PLLD & 0x3f) << 0)
#define REG_070F  ((FASTLOCK_BW0_PLLD & 0x3f) << 0)
#define REG_0710  ((FASTLOCK_BW1_PLLD & 0x3f) << 0)
#define REG_0711  ((FASTLOCK_BW2_PLLD & 0x3f) << 0)
#define REG_0712  ((FASTLOCK_BW3_PLLD & 0x3f) << 0)
#define REG_0713  ((FASTLOCK_BW4_PLLD & 0x3f) << 0)
#define REG_0714  ((FASTLOCK_BW5_PLLD & 0x3f) << 0)
#define REG_0715  ((BW_UPDATE_PLLD & 0x1) << 0)
#define REG_0716  (M_NUM_PLLD >> 0 & 0xff)
#define REG_0717  (M_NUM_PLLD >> 8 & 0xff)
#define REG_0718  (M_NUM_PLLD >> 16 & 0xff)
#define REG_0719  (M_NUM_PLLD >> 24 & 0xff)
#define REG_071A  (M_NUM_PLLD >> 32 & 0xff)
#define REG_071B  (M_NUM_PLLD >> 40 & 0xff)
#define REG_071C  (M_NUM_PLLD >> 48 & 0xff)
#define REG_071D  (M_DEN_PLLD >> 0 & 0xff)
#define REG_071E  (M_DEN_PLLD >> 8 & 0xff)
#define REG_071F  (M_DEN_PLLD >> 16 & 0xff)
#define REG_0720  (M_DEN_PLLD >> 24 & 0xff)
#define REG_0721  ((M_UPDATE_PLLD & 0x1) << 0)
#define REG_0722  ((1 & 0x1) << 5) | ((M_FRAC_EN_PLLD & 0x1) << 4) | ((M_FRAC_MODE_PLLD & 0xf) << 0) // bit 5 Must be set to 1 for DSPLL D
#define REG_0723  ((M_FSTEPW_DEN_PLLD & 0x1) << 1) |((M_FSTEP_MSK_PLLD & 0x1) << 0)
#define REG_0724  (M_FSTEPW_PLLD >> 0 & 0xff)
#define REG_0725  (M_FSTEPW_PLLD >> 8 & 0xff)
#define REG_0726  (M_FSTEPW_PLLD >> 16 & 0xff)
#define REG_0727  (M_FSTEPW_PLLD >> 24 & 0xff)
#define REG_0728  (M_FSTEPW_PLLD >> 32 & 0xff)
#define REG_0729  (M_FSTEPW_PLLD >> 40 & 0xff)
#define REG_072A  (M_FSTEPW_PLLD >> 48 & 0xff)
#define REG_072B  ((IN_SEL_PLLD & 0x7) << 0)
#define REG_072C  ((FASTLOCK_MAN_PLLD & 0x1) << 1) | ((FASTLOCK_AUTO_EN_PLLD & 0x1) << 0)
#define REG_072D  ((RAMP_STEP_INTERVAL_PLLD & 0x7) << 5) | ((HOLDEXIT_BW_SEL1_PLLD & 0x1) << 4) | ((HOLD_RAMP_BYP_PLLD & 0x1) << 3) | ((3 & 0x3) << 1) | ((HOLD_EN_PLLD & 0x1) << 0)
#define REG_072F  ((HOLD_HIST_LEN_PLLD & 0x1f) << 0)
#define REG_0730  ((HOLD_HIST_DELAY_PLLD & 0x1f) << 0)
#define REG_0733  (HOLD_15M_CYC_COUNT_PLLD >> 0 & 0xff)
#define REG_0734  (HOLD_15M_CYC_COUNT_PLLD >> 8 & 0xff)
#define REG_0735  (HOLD_15M_CYC_COUNT_PLLD >> 16 & 0xff)
#define REG_0736  ((FORCE_HOLD_PLLD & 0x1) << 0)
#define REG_0737  ((HSW_EN_PLLD & 0x1) << 2) | ((CLK_SWITCH_MODE_PLLD & 0x3) << 0)
#define REG_073B  ((HSW_PHMEAS_CTRL_PLLD & 0x3) << 0) | ((HSW_MODE_PLLD & 0x3) << 0)
#define REG_073C  (HSW_PHMEAS_THR_PLLD >> 0 & 0xff)
#define REG_073D  (HSW_PHMEAS_THR_PLLD >> 8 & 0x3)
#define REG_073E  ((HSW_COARSE_PM_LEN_PLLD & 0x1f) << 0)
#define REG_073F  ((HSW_COARSE_PM_DLY_PLLD & 0x1f) << 0)
#define REG_0788  ((HSW_FINE_PM_LEN_PLLD & 0xf) << 0)
#define REG_0789  (PFD_EN_DELAY_PLLD >> 0 & 0xff)
#define REG_078A  (PFD_EN_DELAY_PLLD >> 8 & 0x1f)
#define REG_078B  (HSW_MEAS_SETTLE_PLLD >> 0 & 0xff)
#define REG_078C  (HSW_MEAS_SETTLE_PLLD >> 8 & 0xff)
#define REG_078D  (HSW_MEAS_SETTLE_PLLD >> 16 & 0xf)
#define REG_079B  ((HOLDEXIT_STD_BO_PLLD & 0x1) << 7) | \
                  ((HOLDEXIT_BW_SEL0_PLLD & 0x1) << 6) | \
                  ((HOLD_FRZ_WITH_INTONLY_PLLD & 0x1) << 5) | \
                  ((HOLD_PRESERVE_HIST_PLLD & 0x1) << 4) | \
                  ((1 & 0x1) << 3) | \
                  ((HO_SKIP_PHASE_PLLD & 0x1) << 2) | \
                  ((INIT_LP_CLOSE_HO_PLLD & 0x1) << 1) | \
                  ((0 & 0x1) << 0)
#define REG_079C  ((HOLD_RAMPBP_NOHIST_PLLD & 0x1) << 7) | ((HOLDEXIT_ST_BO_PLLD & 0x1) << 6) | ((0x0c & 0x3f) << 0)
#define REG_079D  ((HOLDEXIT_BW0_PLLD & 0x3f) << 0)
#define REG_079E  ((HOLDEXIT_BW1_PLLD & 0x3f) << 0)
#define REG_079F  ((HOLDEXIT_BW2_PLLD & 0x3f) << 0)
#define REG_07A0  ((HOLDEXIT_BW3_PLLD & 0x3f) << 0)
#define REG_07A1  ((HOLDEXIT_BW4_PLLD & 0x3f) << 0)
#define REG_07A2  ((HOLDEXIT_BW5_PLLD & 0x3f) << 0)
#define REG_07A4  (HSW_LIMIT_PLLD >> 0 & 0xff)
#define REG_07A5  ((HSW_LIMIT_ACTION_PLLD & 0x1) << 0)
#define REG_07A6  ((RAMP_SWITCH_EN_PLLD & 0x1) << 3) | ((RAMP_STEP_SIZE_PLLD & 0x7) << 0)
#define REG_07AC  ((HOLD_SETTLE_DEN_EN_DSPLLD & 0x1) << 3) | ((0x0 & 0x3) << 1) | ((OUT_MAX_LIMIT_EN_PLLD & 0x1) << 0)
#define REG_07AD  (OUT_MAX_LIMIT_LMT_PLLD >> 0 & 0xff)
#define REG_07AE  (OUT_MAX_LIMIT_LMT_PLLD >> 8 & 0xff)
#define REG_07B1  (HOLD_SETTLE_TARGET_DSPLLD >> 0 & 0xff)
#define REG_07B2  (HOLD_SETTLE_TARGET_DSPLLD >> 8 & 0xff)
#define REG_0822  (FIXREGSD10 >> 0 & 0xff)
#define REG_0831  (FIXREGSD15 >> 0 & 0xff)
#define REG_090E  ((0x1 & 0x7f) << 1) | ((XAXB_EXTCLK_EN & 0x1) << 0) // Selects between the XTAL or external reference clock on the XA/XB pins. Default is 0 XTAL. Set to 1 to use an external reference oscillator.
#define REG_0949  ((IN_PULSED_CMOS_EN & 0xf) << 4) | ((IN_EN & 0xf) << 0) // in0~3 0: Standard Input Format//1: Pulsed CMOS Input Format for IN3 See for//more information //0: Disable and Powerdown Input Buffer //and free run  //1: enable  Input Buffer//for in0~3
#define REG_094A  ((INX_TO_PFD_EN & 0xf) << 0)
#define REG_0B44  ((FRACN_CLK_DIS_PLLD & 0x1) << 7) | ((FRACN_CLK_DIS_PLLC & 0x1) << 6) | ((FRACN_CLK_DIS_PLLB & 0x1) << 5) | ((FRACN_CLK_DIS_PLLA & 0x1) << 4) | ((PDIV_FRACN_CLK_DIS & 0xf) << 0)
#define REG_0B47  ((OOF_CLK_DIS & 0x1f) << 0)
#define REG_0B48  ((OOF_DIV_CLK_DIS & 0x1f) << 0)
#define REG_0C03  ((IN_CLK_VAL_PWR_UP_DIS & 0xf) << 0)
#define REG_0C09  ((IN_CLK_VAL_EN_PLLC & 0x1) << 0)
#define REG_0C0A  (IN_CLK_VAL_TIME_PLLC >> 0 & 0xff)
#define REG_0C0B  ((IN_CLK_VAL_EN_PLLD & 0x1) << 0)
#define REG_0C0C  (IN_CLK_VAL_TIME_PLLD >> 0 & 0xff)




#define SI5397A_DeviceAddr   0xDE // DE10-Agilex
//#define SI5397A_DeviceAddr   0xD8 // EVB

typedef enum {
    SI5397_XCVR_644M53125 = 0x0,
    SI5397_XCVR_625M,
    SI5397_XCVR_322M265625,
    SI5397_XCVR_312M5,
    SI5397_XCVR_307M2,
    SI5397_XCVR_250M,
    SI5397_XCVR_184M32,
    SI5397_XCVR_156M25,     // (default)
    SI5397_XCVR_153M6,
    SI5397_XCVR_125M,
    SI5397_XCVR_100M,
    SI5397_XCVR_NONE = 0xF,
    SI5397_IO_50M = 0x10,   // XA 48MHz --> DSPLL free-run 50MHZ --> OUT (default)
    SI5397_IO_IN0,          // IN0 (from FPGA, assume 30.72MHz)--> DSPLLx clean --> OUT
    SI5397_IO_IN1,          // IN1 (from FPGA, assume 31.25MHz)--> DSPLLx clean --> OUT
    SI5397_IO_IN2,          // IN2 (30.72MHz)--> DSPLLx clean --> OUT
    SI5397_IO_IN3,          // IN3 (from UFL, assume 10MHz)--> DSPLLx clean --> OUT
} SI5397A_FREQ_ID;

bool SI5397A_Config(uint32_t i2c_base, SI5397A_FREQ_ID FreqID0,
		SI5397A_FREQ_ID FreqID2, SI5397A_FREQ_ID FreqID4,
		SI5397A_FREQ_ID FreqID6, SI5397A_FREQ_ID FreqID7);
bool SI5397A_w_reg(uint32_t i2c_base, uint8_t reg_index, uint8_t data8);
bool SI5397A_r_reg(uint32_t i2c_base, uint8_t reg_index, uint8_t *data8);
bool SI5397A_Config_Init(uint32_t i2c_base);
bool SI5397A_Status(uint32_t i2c_base);

#endif /* SI57X_CONFIG_H_ */
